/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
import { RequestArgs, BaseAPI } from '../base';
import { GroupChannelList } from '../models';
import { InviteSendBirdGroupChannelCommand } from '../models';
import { SendBirdGroupChannelModel } from '../models';
/**
 * GroupChannelsApi - axios parameter creator
 * @export
 */
export declare const GroupChannelsApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     *
     * @summary invite user to group channel
     * @param {string} channelUrl
     * @param {InviteSendBirdGroupChannelCommand} [inviteSendBirdGroupChannelCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1GroupchannelsChannelUrlInvitePost: (channelUrl: string, inviteSendBirdGroupChannelCommand?: InviteSendBirdGroupChannelCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get group channel list
     * @param {string} [nextToken]
     * @param {string} [userId]
     * @param {string} [customType]
     * @param {number} [limit]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1GroupchannelsGet: (nextToken?: string, userId?: string, customType?: string, limit?: number, options?: AxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * GroupChannelsApi - functional programming interface
 * @export
 */
export declare const GroupChannelsApiFp: (configuration?: Configuration) => {
    /**
     *
     * @summary invite user to group channel
     * @param {string} channelUrl
     * @param {InviteSendBirdGroupChannelCommand} [inviteSendBirdGroupChannelCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1GroupchannelsChannelUrlInvitePost(channelUrl: string, inviteSendBirdGroupChannelCommand?: InviteSendBirdGroupChannelCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SendBirdGroupChannelModel>>;
    /**
     *
     * @summary Get group channel list
     * @param {string} [nextToken]
     * @param {string} [userId]
     * @param {string} [customType]
     * @param {number} [limit]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1GroupchannelsGet(nextToken?: string, userId?: string, customType?: string, limit?: number, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<GroupChannelList>>;
};
/**
 * GroupChannelsApi - factory interface
 * @export
 */
export declare const GroupChannelsApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     *
     * @summary invite user to group channel
     * @param {string} channelUrl
     * @param {InviteSendBirdGroupChannelCommand} [inviteSendBirdGroupChannelCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1GroupchannelsChannelUrlInvitePost(channelUrl: string, inviteSendBirdGroupChannelCommand?: InviteSendBirdGroupChannelCommand, options?: any): AxiosPromise<SendBirdGroupChannelModel>;
    /**
     *
     * @summary Get group channel list
     * @param {string} [nextToken]
     * @param {string} [userId]
     * @param {string} [customType]
     * @param {number} [limit]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1GroupchannelsGet(nextToken?: string, userId?: string, customType?: string, limit?: number, options?: any): AxiosPromise<GroupChannelList>;
};
/**
 * Request parameters for apiV1GroupchannelsChannelUrlInvitePost operation in GroupChannelsApi.
 * @export
 * @interface GroupChannelsApiApiV1GroupchannelsChannelUrlInvitePostRequest
 */
export interface GroupChannelsApiApiV1GroupchannelsChannelUrlInvitePostRequest {
    /**
     *
     * @type {string}
     * @memberof GroupChannelsApiApiV1GroupchannelsChannelUrlInvitePost
     */
    readonly channelUrl: string;
    /**
     *
     * @type {InviteSendBirdGroupChannelCommand}
     * @memberof GroupChannelsApiApiV1GroupchannelsChannelUrlInvitePost
     */
    readonly inviteSendBirdGroupChannelCommand?: InviteSendBirdGroupChannelCommand;
}
/**
 * Request parameters for apiV1GroupchannelsGet operation in GroupChannelsApi.
 * @export
 * @interface GroupChannelsApiApiV1GroupchannelsGetRequest
 */
export interface GroupChannelsApiApiV1GroupchannelsGetRequest {
    /**
     *
     * @type {string}
     * @memberof GroupChannelsApiApiV1GroupchannelsGet
     */
    readonly nextToken?: string;
    /**
     *
     * @type {string}
     * @memberof GroupChannelsApiApiV1GroupchannelsGet
     */
    readonly userId?: string;
    /**
     *
     * @type {string}
     * @memberof GroupChannelsApiApiV1GroupchannelsGet
     */
    readonly customType?: string;
    /**
     *
     * @type {number}
     * @memberof GroupChannelsApiApiV1GroupchannelsGet
     */
    readonly limit?: number;
}
/**
 * GroupChannelsApi - object-oriented interface
 * @export
 * @class GroupChannelsApi
 * @extends {BaseAPI}
 */
export declare class GroupChannelsApi extends BaseAPI {
    /**
     *
     * @summary invite user to group channel
     * @param {GroupChannelsApiApiV1GroupchannelsChannelUrlInvitePostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof GroupChannelsApi
     */
    apiV1GroupchannelsChannelUrlInvitePost(requestParameters: GroupChannelsApiApiV1GroupchannelsChannelUrlInvitePostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<SendBirdGroupChannelModel, any>>;
    /**
     *
     * @summary Get group channel list
     * @param {GroupChannelsApiApiV1GroupchannelsGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof GroupChannelsApi
     */
    apiV1GroupchannelsGet(requestParameters?: GroupChannelsApiApiV1GroupchannelsGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<GroupChannelList, any>>;
}
//# sourceMappingURL=group-channels-api.d.ts.map