/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
import { RequestArgs, BaseAPI } from '../base';
import { PatientAffiliationModel } from '../models';
import { PatientAffiliationsModel } from '../models';
/**
 * PatientAffiliationsApi - axios parameter creator
 * @export
 */
export declare const PatientAffiliationsApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     *
     * @summary Get all patientAffiliations
     * @param {string} [languageCode]
     * @param {string} [hospitalId]
     * @param {string} [patientId]
     * @param {string} [patientName]
     * @param {string} [patientPhoneNumber]
     * @param {boolean} [showHidden]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PatientaffiliationsGet: (languageCode?: string, hospitalId?: string, patientId?: string, patientName?: string, patientPhoneNumber?: string, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get patientAffiliation by id
     * @param {string} patientAffiliationId
     * @param {string} [languageCode]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PatientaffiliationsPatientAffiliationIdGet: (patientAffiliationId: string, languageCode?: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * PatientAffiliationsApi - functional programming interface
 * @export
 */
export declare const PatientAffiliationsApiFp: (configuration?: Configuration) => {
    /**
     *
     * @summary Get all patientAffiliations
     * @param {string} [languageCode]
     * @param {string} [hospitalId]
     * @param {string} [patientId]
     * @param {string} [patientName]
     * @param {string} [patientPhoneNumber]
     * @param {boolean} [showHidden]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PatientaffiliationsGet(languageCode?: string, hospitalId?: string, patientId?: string, patientName?: string, patientPhoneNumber?: string, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<PatientAffiliationsModel>>;
    /**
     *
     * @summary Get patientAffiliation by id
     * @param {string} patientAffiliationId
     * @param {string} [languageCode]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PatientaffiliationsPatientAffiliationIdGet(patientAffiliationId: string, languageCode?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<PatientAffiliationModel>>;
};
/**
 * PatientAffiliationsApi - factory interface
 * @export
 */
export declare const PatientAffiliationsApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     *
     * @summary Get all patientAffiliations
     * @param {string} [languageCode]
     * @param {string} [hospitalId]
     * @param {string} [patientId]
     * @param {string} [patientName]
     * @param {string} [patientPhoneNumber]
     * @param {boolean} [showHidden]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PatientaffiliationsGet(languageCode?: string, hospitalId?: string, patientId?: string, patientName?: string, patientPhoneNumber?: string, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<PatientAffiliationsModel>;
    /**
     *
     * @summary Get patientAffiliation by id
     * @param {string} patientAffiliationId
     * @param {string} [languageCode]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1PatientaffiliationsPatientAffiliationIdGet(patientAffiliationId: string, languageCode?: string, options?: any): AxiosPromise<PatientAffiliationModel>;
};
/**
 * Request parameters for apiV1PatientaffiliationsGet operation in PatientAffiliationsApi.
 * @export
 * @interface PatientAffiliationsApiApiV1PatientaffiliationsGetRequest
 */
export interface PatientAffiliationsApiApiV1PatientaffiliationsGetRequest {
    /**
     *
     * @type {string}
     * @memberof PatientAffiliationsApiApiV1PatientaffiliationsGet
     */
    readonly languageCode?: string;
    /**
     *
     * @type {string}
     * @memberof PatientAffiliationsApiApiV1PatientaffiliationsGet
     */
    readonly hospitalId?: string;
    /**
     *
     * @type {string}
     * @memberof PatientAffiliationsApiApiV1PatientaffiliationsGet
     */
    readonly patientId?: string;
    /**
     *
     * @type {string}
     * @memberof PatientAffiliationsApiApiV1PatientaffiliationsGet
     */
    readonly patientName?: string;
    /**
     *
     * @type {string}
     * @memberof PatientAffiliationsApiApiV1PatientaffiliationsGet
     */
    readonly patientPhoneNumber?: string;
    /**
     *
     * @type {boolean}
     * @memberof PatientAffiliationsApiApiV1PatientaffiliationsGet
     */
    readonly showHidden?: boolean;
    /**
     *
     * @type {number}
     * @memberof PatientAffiliationsApiApiV1PatientaffiliationsGet
     */
    readonly page?: number;
    /**
     *
     * @type {number}
     * @memberof PatientAffiliationsApiApiV1PatientaffiliationsGet
     */
    readonly limit?: number;
    /**
     *
     * @type {Date}
     * @memberof PatientAffiliationsApiApiV1PatientaffiliationsGet
     */
    readonly lastRetrieved?: Date;
}
/**
 * Request parameters for apiV1PatientaffiliationsPatientAffiliationIdGet operation in PatientAffiliationsApi.
 * @export
 * @interface PatientAffiliationsApiApiV1PatientaffiliationsPatientAffiliationIdGetRequest
 */
export interface PatientAffiliationsApiApiV1PatientaffiliationsPatientAffiliationIdGetRequest {
    /**
     *
     * @type {string}
     * @memberof PatientAffiliationsApiApiV1PatientaffiliationsPatientAffiliationIdGet
     */
    readonly patientAffiliationId: string;
    /**
     *
     * @type {string}
     * @memberof PatientAffiliationsApiApiV1PatientaffiliationsPatientAffiliationIdGet
     */
    readonly languageCode?: string;
}
/**
 * PatientAffiliationsApi - object-oriented interface
 * @export
 * @class PatientAffiliationsApi
 * @extends {BaseAPI}
 */
export declare class PatientAffiliationsApi extends BaseAPI {
    /**
     *
     * @summary Get all patientAffiliations
     * @param {PatientAffiliationsApiApiV1PatientaffiliationsGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PatientAffiliationsApi
     */
    apiV1PatientaffiliationsGet(requestParameters?: PatientAffiliationsApiApiV1PatientaffiliationsGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<PatientAffiliationsModel, any>>;
    /**
     *
     * @summary Get patientAffiliation by id
     * @param {PatientAffiliationsApiApiV1PatientaffiliationsPatientAffiliationIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PatientAffiliationsApi
     */
    apiV1PatientaffiliationsPatientAffiliationIdGet(requestParameters: PatientAffiliationsApiApiV1PatientaffiliationsPatientAffiliationIdGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<PatientAffiliationModel, any>>;
}
//# sourceMappingURL=patient-affiliations-api.d.ts.map