/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
import { RequestArgs, BaseAPI } from '../base';
import { SearchIndexType } from '../models';
/**
 * SearchApi - axios parameter creator
 * @export
 */
export declare const SearchApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     *
     * @summary Upload documents into azure search index.    <br>To start uploading from where it left off, enter the current number of documents into skip value.
     * @param {SearchIndexType} selectedIndextype
     * @param {number} [skip] To start uploading from where it left off, enter the current number of documents into skip value.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SearchDocumentsPost: (selectedIndextype: SearchIndexType, skip?: number, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Recreate Index
     * @param {Array<SearchIndexType>} selectedIndextypes
     * @param {boolean} [recreateIndex]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SearchRecreatePost: (selectedIndextypes: Array<SearchIndexType>, recreateIndex?: boolean, options?: AxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * SearchApi - functional programming interface
 * @export
 */
export declare const SearchApiFp: (configuration?: Configuration) => {
    /**
     *
     * @summary Upload documents into azure search index.    <br>To start uploading from where it left off, enter the current number of documents into skip value.
     * @param {SearchIndexType} selectedIndextype
     * @param {number} [skip] To start uploading from where it left off, enter the current number of documents into skip value.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SearchDocumentsPost(selectedIndextype: SearchIndexType, skip?: number, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<string>>;
    /**
     *
     * @summary Recreate Index
     * @param {Array<SearchIndexType>} selectedIndextypes
     * @param {boolean} [recreateIndex]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SearchRecreatePost(selectedIndextypes: Array<SearchIndexType>, recreateIndex?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<string>>;
};
/**
 * SearchApi - factory interface
 * @export
 */
export declare const SearchApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     *
     * @summary Upload documents into azure search index.    <br>To start uploading from where it left off, enter the current number of documents into skip value.
     * @param {SearchIndexType} selectedIndextype
     * @param {number} [skip] To start uploading from where it left off, enter the current number of documents into skip value.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SearchDocumentsPost(selectedIndextype: SearchIndexType, skip?: number, options?: any): AxiosPromise<string>;
    /**
     *
     * @summary Recreate Index
     * @param {Array<SearchIndexType>} selectedIndextypes
     * @param {boolean} [recreateIndex]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SearchRecreatePost(selectedIndextypes: Array<SearchIndexType>, recreateIndex?: boolean, options?: any): AxiosPromise<string>;
};
/**
 * Request parameters for apiV1SearchDocumentsPost operation in SearchApi.
 * @export
 * @interface SearchApiApiV1SearchDocumentsPostRequest
 */
export interface SearchApiApiV1SearchDocumentsPostRequest {
    /**
     *
     * @type {SearchIndexType}
     * @memberof SearchApiApiV1SearchDocumentsPost
     */
    readonly selectedIndextype: SearchIndexType;
    /**
     * To start uploading from where it left off, enter the current number of documents into skip value.
     * @type {number}
     * @memberof SearchApiApiV1SearchDocumentsPost
     */
    readonly skip?: number;
}
/**
 * Request parameters for apiV1SearchRecreatePost operation in SearchApi.
 * @export
 * @interface SearchApiApiV1SearchRecreatePostRequest
 */
export interface SearchApiApiV1SearchRecreatePostRequest {
    /**
     *
     * @type {Array<SearchIndexType>}
     * @memberof SearchApiApiV1SearchRecreatePost
     */
    readonly selectedIndextypes: Array<SearchIndexType>;
    /**
     *
     * @type {boolean}
     * @memberof SearchApiApiV1SearchRecreatePost
     */
    readonly recreateIndex?: boolean;
}
/**
 * SearchApi - object-oriented interface
 * @export
 * @class SearchApi
 * @extends {BaseAPI}
 */
export declare class SearchApi extends BaseAPI {
    /**
     *
     * @summary Upload documents into azure search index.    <br>To start uploading from where it left off, enter the current number of documents into skip value.
     * @param {SearchApiApiV1SearchDocumentsPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SearchApi
     */
    apiV1SearchDocumentsPost(requestParameters: SearchApiApiV1SearchDocumentsPostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<string, any>>;
    /**
     *
     * @summary Recreate Index
     * @param {SearchApiApiV1SearchRecreatePostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SearchApi
     */
    apiV1SearchRecreatePost(requestParameters: SearchApiApiV1SearchRecreatePostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<string, any>>;
}
//# sourceMappingURL=search-api.d.ts.map