/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
import { RequestArgs, BaseAPI } from '../base';
import { AddOrUpdateWebAppEnvironmentsCommand } from '../models';
import { CreateWebAppCommand } from '../models';
import { DeployStatus } from '../models';
import { UpdateWebAppCommand } from '../models';
import { WebAppEnvironmentsModel } from '../models';
import { WebAppModel } from '../models';
import { WebAppsModel } from '../models';
/**
 * WebAppsApi - axios parameter creator
 * @export
 */
export declare const WebAppsApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     *
     * @summary Upload favicon
     * @param {string} [id]
     * @param {File} [formFile]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1WebappsFaviconPost: (id?: string, formFile?: File, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Retrive all WebApp configuration
     * @param {string} [id]
     * @param {string} [hospitalId]
     * @param {string} [hospitalName]
     * @param {string} [appName]
     * @param {string} [hostName]
     * @param {DeployStatus} [deployStatus]
     * @param {string} [languageCode]
     * @param {boolean} [showHidden]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1WebappsGet: (id?: string, hospitalId?: string, hospitalName?: string, appName?: string, hostName?: string, deployStatus?: DeployStatus, languageCode?: string, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Delete WebApp configuration soft or permanent
     * @param {string} id
     * @param {boolean} [isPermanent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1WebappsIdDelete: (id: string, isPermanent?: boolean, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary GET Webapp Environment Variables
     * @param {string} id
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1WebappsIdEnvironmentvariablesGet: (id: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Add or update webAppEnvironments
     * @param {string} id
     * @param {AddOrUpdateWebAppEnvironmentsCommand} [addOrUpdateWebAppEnvironmentsCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1WebappsIdEnvironmentvariablesPatch: (id: string, addOrUpdateWebAppEnvironmentsCommand?: AddOrUpdateWebAppEnvironmentsCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Retrive WebApp configuration
     * @param {string} id
     * @param {string} [languageCode]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1WebappsIdGet: (id: string, languageCode?: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Update WebApp configuration
     * @param {string} id
     * @param {UpdateWebAppCommand} [updateWebAppCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1WebappsIdPut: (id: string, updateWebAppCommand?: UpdateWebAppCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Reactivate WebApp
     * @param {string} id
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1WebappsIdReactivatePut: (id: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Create WebApp configuration
     * @param {CreateWebAppCommand} [createWebAppCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1WebappsPost: (createWebAppCommand?: CreateWebAppCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * WebAppsApi - functional programming interface
 * @export
 */
export declare const WebAppsApiFp: (configuration?: Configuration) => {
    /**
     *
     * @summary Upload favicon
     * @param {string} [id]
     * @param {File} [formFile]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1WebappsFaviconPost(id?: string, formFile?: File, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<Array<string>>>;
    /**
     *
     * @summary Retrive all WebApp configuration
     * @param {string} [id]
     * @param {string} [hospitalId]
     * @param {string} [hospitalName]
     * @param {string} [appName]
     * @param {string} [hostName]
     * @param {DeployStatus} [deployStatus]
     * @param {string} [languageCode]
     * @param {boolean} [showHidden]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1WebappsGet(id?: string, hospitalId?: string, hospitalName?: string, appName?: string, hostName?: string, deployStatus?: DeployStatus, languageCode?: string, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<WebAppsModel>>;
    /**
     *
     * @summary Delete WebApp configuration soft or permanent
     * @param {string} id
     * @param {boolean} [isPermanent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1WebappsIdDelete(id: string, isPermanent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary GET Webapp Environment Variables
     * @param {string} id
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1WebappsIdEnvironmentvariablesGet(id: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<WebAppEnvironmentsModel>>;
    /**
     *
     * @summary Add or update webAppEnvironments
     * @param {string} id
     * @param {AddOrUpdateWebAppEnvironmentsCommand} [addOrUpdateWebAppEnvironmentsCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1WebappsIdEnvironmentvariablesPatch(id: string, addOrUpdateWebAppEnvironmentsCommand?: AddOrUpdateWebAppEnvironmentsCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Retrive WebApp configuration
     * @param {string} id
     * @param {string} [languageCode]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1WebappsIdGet(id: string, languageCode?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<WebAppModel>>;
    /**
     *
     * @summary Update WebApp configuration
     * @param {string} id
     * @param {UpdateWebAppCommand} [updateWebAppCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1WebappsIdPut(id: string, updateWebAppCommand?: UpdateWebAppCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<WebAppModel>>;
    /**
     *
     * @summary Reactivate WebApp
     * @param {string} id
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1WebappsIdReactivatePut(id: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Create WebApp configuration
     * @param {CreateWebAppCommand} [createWebAppCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1WebappsPost(createWebAppCommand?: CreateWebAppCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<WebAppModel>>;
};
/**
 * WebAppsApi - factory interface
 * @export
 */
export declare const WebAppsApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     *
     * @summary Upload favicon
     * @param {string} [id]
     * @param {File} [formFile]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1WebappsFaviconPost(id?: string, formFile?: File, options?: any): AxiosPromise<Array<string>>;
    /**
     *
     * @summary Retrive all WebApp configuration
     * @param {string} [id]
     * @param {string} [hospitalId]
     * @param {string} [hospitalName]
     * @param {string} [appName]
     * @param {string} [hostName]
     * @param {DeployStatus} [deployStatus]
     * @param {string} [languageCode]
     * @param {boolean} [showHidden]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1WebappsGet(id?: string, hospitalId?: string, hospitalName?: string, appName?: string, hostName?: string, deployStatus?: DeployStatus, languageCode?: string, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<WebAppsModel>;
    /**
     *
     * @summary Delete WebApp configuration soft or permanent
     * @param {string} id
     * @param {boolean} [isPermanent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1WebappsIdDelete(id: string, isPermanent?: boolean, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary GET Webapp Environment Variables
     * @param {string} id
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1WebappsIdEnvironmentvariablesGet(id: string, options?: any): AxiosPromise<WebAppEnvironmentsModel>;
    /**
     *
     * @summary Add or update webAppEnvironments
     * @param {string} id
     * @param {AddOrUpdateWebAppEnvironmentsCommand} [addOrUpdateWebAppEnvironmentsCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1WebappsIdEnvironmentvariablesPatch(id: string, addOrUpdateWebAppEnvironmentsCommand?: AddOrUpdateWebAppEnvironmentsCommand, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Retrive WebApp configuration
     * @param {string} id
     * @param {string} [languageCode]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1WebappsIdGet(id: string, languageCode?: string, options?: any): AxiosPromise<WebAppModel>;
    /**
     *
     * @summary Update WebApp configuration
     * @param {string} id
     * @param {UpdateWebAppCommand} [updateWebAppCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1WebappsIdPut(id: string, updateWebAppCommand?: UpdateWebAppCommand, options?: any): AxiosPromise<WebAppModel>;
    /**
     *
     * @summary Reactivate WebApp
     * @param {string} id
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1WebappsIdReactivatePut(id: string, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Create WebApp configuration
     * @param {CreateWebAppCommand} [createWebAppCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1WebappsPost(createWebAppCommand?: CreateWebAppCommand, options?: any): AxiosPromise<WebAppModel>;
};
/**
 * Request parameters for apiV1WebappsFaviconPost operation in WebAppsApi.
 * @export
 * @interface WebAppsApiApiV1WebappsFaviconPostRequest
 */
export interface WebAppsApiApiV1WebappsFaviconPostRequest {
    /**
     *
     * @type {string}
     * @memberof WebAppsApiApiV1WebappsFaviconPost
     */
    readonly id?: string;
    /**
     *
     * @type {File}
     * @memberof WebAppsApiApiV1WebappsFaviconPost
     */
    readonly formFile?: File;
}
/**
 * Request parameters for apiV1WebappsGet operation in WebAppsApi.
 * @export
 * @interface WebAppsApiApiV1WebappsGetRequest
 */
export interface WebAppsApiApiV1WebappsGetRequest {
    /**
     *
     * @type {string}
     * @memberof WebAppsApiApiV1WebappsGet
     */
    readonly id?: string;
    /**
     *
     * @type {string}
     * @memberof WebAppsApiApiV1WebappsGet
     */
    readonly hospitalId?: string;
    /**
     *
     * @type {string}
     * @memberof WebAppsApiApiV1WebappsGet
     */
    readonly hospitalName?: string;
    /**
     *
     * @type {string}
     * @memberof WebAppsApiApiV1WebappsGet
     */
    readonly appName?: string;
    /**
     *
     * @type {string}
     * @memberof WebAppsApiApiV1WebappsGet
     */
    readonly hostName?: string;
    /**
     *
     * @type {DeployStatus}
     * @memberof WebAppsApiApiV1WebappsGet
     */
    readonly deployStatus?: DeployStatus;
    /**
     *
     * @type {string}
     * @memberof WebAppsApiApiV1WebappsGet
     */
    readonly languageCode?: string;
    /**
     *
     * @type {boolean}
     * @memberof WebAppsApiApiV1WebappsGet
     */
    readonly showHidden?: boolean;
    /**
     *
     * @type {number}
     * @memberof WebAppsApiApiV1WebappsGet
     */
    readonly page?: number;
    /**
     *
     * @type {number}
     * @memberof WebAppsApiApiV1WebappsGet
     */
    readonly limit?: number;
    /**
     *
     * @type {Date}
     * @memberof WebAppsApiApiV1WebappsGet
     */
    readonly lastRetrieved?: Date;
}
/**
 * Request parameters for apiV1WebappsIdDelete operation in WebAppsApi.
 * @export
 * @interface WebAppsApiApiV1WebappsIdDeleteRequest
 */
export interface WebAppsApiApiV1WebappsIdDeleteRequest {
    /**
     *
     * @type {string}
     * @memberof WebAppsApiApiV1WebappsIdDelete
     */
    readonly id: string;
    /**
     *
     * @type {boolean}
     * @memberof WebAppsApiApiV1WebappsIdDelete
     */
    readonly isPermanent?: boolean;
}
/**
 * Request parameters for apiV1WebappsIdEnvironmentvariablesGet operation in WebAppsApi.
 * @export
 * @interface WebAppsApiApiV1WebappsIdEnvironmentvariablesGetRequest
 */
export interface WebAppsApiApiV1WebappsIdEnvironmentvariablesGetRequest {
    /**
     *
     * @type {string}
     * @memberof WebAppsApiApiV1WebappsIdEnvironmentvariablesGet
     */
    readonly id: string;
}
/**
 * Request parameters for apiV1WebappsIdEnvironmentvariablesPatch operation in WebAppsApi.
 * @export
 * @interface WebAppsApiApiV1WebappsIdEnvironmentvariablesPatchRequest
 */
export interface WebAppsApiApiV1WebappsIdEnvironmentvariablesPatchRequest {
    /**
     *
     * @type {string}
     * @memberof WebAppsApiApiV1WebappsIdEnvironmentvariablesPatch
     */
    readonly id: string;
    /**
     *
     * @type {AddOrUpdateWebAppEnvironmentsCommand}
     * @memberof WebAppsApiApiV1WebappsIdEnvironmentvariablesPatch
     */
    readonly addOrUpdateWebAppEnvironmentsCommand?: AddOrUpdateWebAppEnvironmentsCommand;
}
/**
 * Request parameters for apiV1WebappsIdGet operation in WebAppsApi.
 * @export
 * @interface WebAppsApiApiV1WebappsIdGetRequest
 */
export interface WebAppsApiApiV1WebappsIdGetRequest {
    /**
     *
     * @type {string}
     * @memberof WebAppsApiApiV1WebappsIdGet
     */
    readonly id: string;
    /**
     *
     * @type {string}
     * @memberof WebAppsApiApiV1WebappsIdGet
     */
    readonly languageCode?: string;
}
/**
 * Request parameters for apiV1WebappsIdPut operation in WebAppsApi.
 * @export
 * @interface WebAppsApiApiV1WebappsIdPutRequest
 */
export interface WebAppsApiApiV1WebappsIdPutRequest {
    /**
     *
     * @type {string}
     * @memberof WebAppsApiApiV1WebappsIdPut
     */
    readonly id: string;
    /**
     *
     * @type {UpdateWebAppCommand}
     * @memberof WebAppsApiApiV1WebappsIdPut
     */
    readonly updateWebAppCommand?: UpdateWebAppCommand;
}
/**
 * Request parameters for apiV1WebappsIdReactivatePut operation in WebAppsApi.
 * @export
 * @interface WebAppsApiApiV1WebappsIdReactivatePutRequest
 */
export interface WebAppsApiApiV1WebappsIdReactivatePutRequest {
    /**
     *
     * @type {string}
     * @memberof WebAppsApiApiV1WebappsIdReactivatePut
     */
    readonly id: string;
}
/**
 * Request parameters for apiV1WebappsPost operation in WebAppsApi.
 * @export
 * @interface WebAppsApiApiV1WebappsPostRequest
 */
export interface WebAppsApiApiV1WebappsPostRequest {
    /**
     *
     * @type {CreateWebAppCommand}
     * @memberof WebAppsApiApiV1WebappsPost
     */
    readonly createWebAppCommand?: CreateWebAppCommand;
}
/**
 * WebAppsApi - object-oriented interface
 * @export
 * @class WebAppsApi
 * @extends {BaseAPI}
 */
export declare class WebAppsApi extends BaseAPI {
    /**
     *
     * @summary Upload favicon
     * @param {WebAppsApiApiV1WebappsFaviconPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof WebAppsApi
     */
    apiV1WebappsFaviconPost(requestParameters?: WebAppsApiApiV1WebappsFaviconPostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<string[], any>>;
    /**
     *
     * @summary Retrive all WebApp configuration
     * @param {WebAppsApiApiV1WebappsGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof WebAppsApi
     */
    apiV1WebappsGet(requestParameters?: WebAppsApiApiV1WebappsGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<WebAppsModel, any>>;
    /**
     *
     * @summary Delete WebApp configuration soft or permanent
     * @param {WebAppsApiApiV1WebappsIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof WebAppsApi
     */
    apiV1WebappsIdDelete(requestParameters: WebAppsApiApiV1WebappsIdDeleteRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary GET Webapp Environment Variables
     * @param {WebAppsApiApiV1WebappsIdEnvironmentvariablesGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof WebAppsApi
     */
    apiV1WebappsIdEnvironmentvariablesGet(requestParameters: WebAppsApiApiV1WebappsIdEnvironmentvariablesGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<WebAppEnvironmentsModel, any>>;
    /**
     *
     * @summary Add or update webAppEnvironments
     * @param {WebAppsApiApiV1WebappsIdEnvironmentvariablesPatchRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof WebAppsApi
     */
    apiV1WebappsIdEnvironmentvariablesPatch(requestParameters: WebAppsApiApiV1WebappsIdEnvironmentvariablesPatchRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Retrive WebApp configuration
     * @param {WebAppsApiApiV1WebappsIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof WebAppsApi
     */
    apiV1WebappsIdGet(requestParameters: WebAppsApiApiV1WebappsIdGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<WebAppModel, any>>;
    /**
     *
     * @summary Update WebApp configuration
     * @param {WebAppsApiApiV1WebappsIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof WebAppsApi
     */
    apiV1WebappsIdPut(requestParameters: WebAppsApiApiV1WebappsIdPutRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<WebAppModel, any>>;
    /**
     *
     * @summary Reactivate WebApp
     * @param {WebAppsApiApiV1WebappsIdReactivatePutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof WebAppsApi
     */
    apiV1WebappsIdReactivatePut(requestParameters: WebAppsApiApiV1WebappsIdReactivatePutRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Create WebApp configuration
     * @param {WebAppsApiApiV1WebappsPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof WebAppsApi
     */
    apiV1WebappsPost(requestParameters?: WebAppsApiApiV1WebappsPostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<WebAppModel, any>>;
}
//# sourceMappingURL=web-apps-api.d.ts.map