/* tslint:disable */
/* eslint-disable */
/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import globalAxios, { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '../base';
// @ts-ignore
import { CallHistoriesModel } from '../models';
// @ts-ignore
import { CallHistoryModel } from '../models';
// @ts-ignore
import { SortingOrder } from '../models';
/**
 * CallHistoriesApi - axios parameter creator
 * @export
 */
export const CallHistoriesApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @param {string} callId 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CallhistoriesCallIdGet: async (callId: string, languageCode?: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'callId' is not null or undefined
            assertParamExists('apiV1CallhistoriesCallIdGet', 'callId', callId)
            const localVarPath = `/api/v1/callhistories/{callId}`
                .replace(`{${"callId"}}`, encodeURIComponent(String(callId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (languageCode !== undefined) {
                localVarQueryParameter['languageCode'] = languageCode;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @param {string} [id] 
         * @param {string} [userId] 
         * @param {string} [userName] 
         * @param {string} [hospitalId] 
         * @param {string} [hospitalName] 
         * @param {string} [virtualNumber] 
         * @param {string} [targetNumber] 
         * @param {Date} [startTime] 
         * @param {Date} [endTime] 
         * @param {SortingOrder} [sortRequestDate] 
         * @param {string} [languageCode] 
         * @param {boolean} [isExternal] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CallhistoriesGet: async (id?: string, userId?: string, userName?: string, hospitalId?: string, hospitalName?: string, virtualNumber?: string, targetNumber?: string, startTime?: Date, endTime?: Date, sortRequestDate?: SortingOrder, languageCode?: string, isExternal?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/callhistories`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (id !== undefined) {
                localVarQueryParameter['Id'] = id;
            }

            if (userId !== undefined) {
                localVarQueryParameter['UserId'] = userId;
            }

            if (userName !== undefined) {
                localVarQueryParameter['UserName'] = userName;
            }

            if (hospitalId !== undefined) {
                localVarQueryParameter['HospitalId'] = hospitalId;
            }

            if (hospitalName !== undefined) {
                localVarQueryParameter['HospitalName'] = hospitalName;
            }

            if (virtualNumber !== undefined) {
                localVarQueryParameter['VirtualNumber'] = virtualNumber;
            }

            if (targetNumber !== undefined) {
                localVarQueryParameter['TargetNumber'] = targetNumber;
            }

            if (startTime !== undefined) {
                localVarQueryParameter['StartTime'] = (startTime as any instanceof Date) ?
                    (startTime as any).toISOString() :
                    startTime;
            }

            if (endTime !== undefined) {
                localVarQueryParameter['EndTime'] = (endTime as any instanceof Date) ?
                    (endTime as any).toISOString() :
                    endTime;
            }

            if (sortRequestDate !== undefined) {
                localVarQueryParameter['SortRequestDate'] = sortRequestDate;
            }

            if (languageCode !== undefined) {
                localVarQueryParameter['LanguageCode'] = languageCode;
            }

            if (isExternal !== undefined) {
                localVarQueryParameter['IsExternal'] = isExternal;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * CallHistoriesApi - functional programming interface
 * @export
 */
export const CallHistoriesApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = CallHistoriesApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @param {string} callId 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1CallhistoriesCallIdGet(callId: string, languageCode?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CallHistoryModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1CallhistoriesCallIdGet(callId, languageCode, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @param {string} [id] 
         * @param {string} [userId] 
         * @param {string} [userName] 
         * @param {string} [hospitalId] 
         * @param {string} [hospitalName] 
         * @param {string} [virtualNumber] 
         * @param {string} [targetNumber] 
         * @param {Date} [startTime] 
         * @param {Date} [endTime] 
         * @param {SortingOrder} [sortRequestDate] 
         * @param {string} [languageCode] 
         * @param {boolean} [isExternal] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1CallhistoriesGet(id?: string, userId?: string, userName?: string, hospitalId?: string, hospitalName?: string, virtualNumber?: string, targetNumber?: string, startTime?: Date, endTime?: Date, sortRequestDate?: SortingOrder, languageCode?: string, isExternal?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<CallHistoriesModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1CallhistoriesGet(id, userId, userName, hospitalId, hospitalName, virtualNumber, targetNumber, startTime, endTime, sortRequestDate, languageCode, isExternal, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * CallHistoriesApi - factory interface
 * @export
 */
export const CallHistoriesApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = CallHistoriesApiFp(configuration)
    return {
        /**
         * 
         * @param {string} callId 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CallhistoriesCallIdGet(callId: string, languageCode?: string, options?: any): AxiosPromise<CallHistoryModel> {
            return localVarFp.apiV1CallhistoriesCallIdGet(callId, languageCode, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @param {string} [id] 
         * @param {string} [userId] 
         * @param {string} [userName] 
         * @param {string} [hospitalId] 
         * @param {string} [hospitalName] 
         * @param {string} [virtualNumber] 
         * @param {string} [targetNumber] 
         * @param {Date} [startTime] 
         * @param {Date} [endTime] 
         * @param {SortingOrder} [sortRequestDate] 
         * @param {string} [languageCode] 
         * @param {boolean} [isExternal] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1CallhistoriesGet(id?: string, userId?: string, userName?: string, hospitalId?: string, hospitalName?: string, virtualNumber?: string, targetNumber?: string, startTime?: Date, endTime?: Date, sortRequestDate?: SortingOrder, languageCode?: string, isExternal?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<CallHistoriesModel> {
            return localVarFp.apiV1CallhistoriesGet(id, userId, userName, hospitalId, hospitalName, virtualNumber, targetNumber, startTime, endTime, sortRequestDate, languageCode, isExternal, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for apiV1CallhistoriesCallIdGet operation in CallHistoriesApi.
 * @export
 * @interface CallHistoriesApiApiV1CallhistoriesCallIdGetRequest
 */
export interface CallHistoriesApiApiV1CallhistoriesCallIdGetRequest {
    /**
     * 
     * @type {string}
     * @memberof CallHistoriesApiApiV1CallhistoriesCallIdGet
     */
    readonly callId: string

    /**
     * 
     * @type {string}
     * @memberof CallHistoriesApiApiV1CallhistoriesCallIdGet
     */
    readonly languageCode?: string
}

/**
 * Request parameters for apiV1CallhistoriesGet operation in CallHistoriesApi.
 * @export
 * @interface CallHistoriesApiApiV1CallhistoriesGetRequest
 */
export interface CallHistoriesApiApiV1CallhistoriesGetRequest {
    /**
     * 
     * @type {string}
     * @memberof CallHistoriesApiApiV1CallhistoriesGet
     */
    readonly id?: string

    /**
     * 
     * @type {string}
     * @memberof CallHistoriesApiApiV1CallhistoriesGet
     */
    readonly userId?: string

    /**
     * 
     * @type {string}
     * @memberof CallHistoriesApiApiV1CallhistoriesGet
     */
    readonly userName?: string

    /**
     * 
     * @type {string}
     * @memberof CallHistoriesApiApiV1CallhistoriesGet
     */
    readonly hospitalId?: string

    /**
     * 
     * @type {string}
     * @memberof CallHistoriesApiApiV1CallhistoriesGet
     */
    readonly hospitalName?: string

    /**
     * 
     * @type {string}
     * @memberof CallHistoriesApiApiV1CallhistoriesGet
     */
    readonly virtualNumber?: string

    /**
     * 
     * @type {string}
     * @memberof CallHistoriesApiApiV1CallhistoriesGet
     */
    readonly targetNumber?: string

    /**
     * 
     * @type {Date}
     * @memberof CallHistoriesApiApiV1CallhistoriesGet
     */
    readonly startTime?: Date

    /**
     * 
     * @type {Date}
     * @memberof CallHistoriesApiApiV1CallhistoriesGet
     */
    readonly endTime?: Date

    /**
     * 
     * @type {SortingOrder}
     * @memberof CallHistoriesApiApiV1CallhistoriesGet
     */
    readonly sortRequestDate?: SortingOrder

    /**
     * 
     * @type {string}
     * @memberof CallHistoriesApiApiV1CallhistoriesGet
     */
    readonly languageCode?: string

    /**
     * 
     * @type {boolean}
     * @memberof CallHistoriesApiApiV1CallhistoriesGet
     */
    readonly isExternal?: boolean

    /**
     * 
     * @type {number}
     * @memberof CallHistoriesApiApiV1CallhistoriesGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof CallHistoriesApiApiV1CallhistoriesGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof CallHistoriesApiApiV1CallhistoriesGet
     */
    readonly lastRetrieved?: Date
}

/**
 * CallHistoriesApi - object-oriented interface
 * @export
 * @class CallHistoriesApi
 * @extends {BaseAPI}
 */
export class CallHistoriesApi extends BaseAPI {
    /**
     * 
     * @param {CallHistoriesApiApiV1CallhistoriesCallIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CallHistoriesApi
     */
    public apiV1CallhistoriesCallIdGet(requestParameters: CallHistoriesApiApiV1CallhistoriesCallIdGetRequest, options?: AxiosRequestConfig) {
        return CallHistoriesApiFp(this.configuration).apiV1CallhistoriesCallIdGet(requestParameters.callId, requestParameters.languageCode, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @param {CallHistoriesApiApiV1CallhistoriesGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CallHistoriesApi
     */
    public apiV1CallhistoriesGet(requestParameters: CallHistoriesApiApiV1CallhistoriesGetRequest = {}, options?: AxiosRequestConfig) {
        return CallHistoriesApiFp(this.configuration).apiV1CallhistoriesGet(requestParameters.id, requestParameters.userId, requestParameters.userName, requestParameters.hospitalId, requestParameters.hospitalName, requestParameters.virtualNumber, requestParameters.targetNumber, requestParameters.startTime, requestParameters.endTime, requestParameters.sortRequestDate, requestParameters.languageCode, requestParameters.isExternal, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }
}
