/* tslint:disable */
/* eslint-disable */
/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import globalAxios, { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '../base';
// @ts-ignore
import { CreatePatientAffiliationCommand } from '../models';
// @ts-ignore
import { CreatePatientCommand } from '../models';
// @ts-ignore
import { Gender } from '../models';
// @ts-ignore
import { GetPatientWalkInQuery } from '../models';
// @ts-ignore
import { PatientAffiliationModel } from '../models';
// @ts-ignore
import { PatientModel } from '../models';
// @ts-ignore
import { PatientWalkInModel } from '../models';
// @ts-ignore
import { PatientsModel } from '../models';
// @ts-ignore
import { ProblemDetails } from '../models';
// @ts-ignore
import { UpdatePatientAffiliationCommand } from '../models';
// @ts-ignore
import { UpdatePatientCommand } from '../models';
/**
 * PatientsApi - axios parameter creator
 * @export
 */
export const PatientsApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Get all Patients.
         * @param {string} [hospitalId] 
         * @param {string} [id] 
         * @param {string} [fullname] 
         * @param {string} [email] 
         * @param {Gender} [gender] 
         * @param {Date} [dateOfBirth] 
         * @param {Date} [created] 
         * @param {boolean} [showHidden] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PatientsGet: async (hospitalId?: string, id?: string, fullname?: string, email?: string, gender?: Gender, dateOfBirth?: Date, created?: Date, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/patients`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (hospitalId !== undefined) {
                localVarQueryParameter['HospitalId'] = hospitalId;
            }

            if (id !== undefined) {
                localVarQueryParameter['Id'] = id;
            }

            if (fullname !== undefined) {
                localVarQueryParameter['Fullname'] = fullname;
            }

            if (email !== undefined) {
                localVarQueryParameter['Email'] = email;
            }

            if (gender !== undefined) {
                localVarQueryParameter['Gender'] = gender;
            }

            if (dateOfBirth !== undefined) {
                localVarQueryParameter['DateOfBirth'] = (dateOfBirth as any instanceof Date) ?
                    (dateOfBirth as any).toISOString() :
                    dateOfBirth;
            }

            if (created !== undefined) {
                localVarQueryParameter['Created'] = (created as any instanceof Date) ?
                    (created as any).toISOString() :
                    created;
            }

            if (showHidden !== undefined) {
                localVarQueryParameter['ShowHidden'] = showHidden;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete patient affiliation
         * @param {string} patientId 
         * @param {string} hospitalId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PatientsPatientIdAffiliationsHospitalIdDelete: async (patientId: string, hospitalId: string, isPermanent?: boolean, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'patientId' is not null or undefined
            assertParamExists('apiV1PatientsPatientIdAffiliationsHospitalIdDelete', 'patientId', patientId)
            // verify required parameter 'hospitalId' is not null or undefined
            assertParamExists('apiV1PatientsPatientIdAffiliationsHospitalIdDelete', 'hospitalId', hospitalId)
            const localVarPath = `/api/v1/patients/{patientId}/affiliations/{hospitalId}`
                .replace(`{${"patientId"}}`, encodeURIComponent(String(patientId)))
                .replace(`{${"hospitalId"}}`, encodeURIComponent(String(hospitalId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (isPermanent !== undefined) {
                localVarQueryParameter['isPermanent'] = isPermanent;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get patientAffiliation by patient id and hospital id.
         * @param {string} patientId 
         * @param {string} hospitalId 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PatientsPatientIdAffiliationsHospitalIdGet: async (patientId: string, hospitalId: string, languageCode?: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'patientId' is not null or undefined
            assertParamExists('apiV1PatientsPatientIdAffiliationsHospitalIdGet', 'patientId', patientId)
            // verify required parameter 'hospitalId' is not null or undefined
            assertParamExists('apiV1PatientsPatientIdAffiliationsHospitalIdGet', 'hospitalId', hospitalId)
            const localVarPath = `/api/v1/patients/{patientId}/affiliations/{hospitalId}`
                .replace(`{${"patientId"}}`, encodeURIComponent(String(patientId)))
                .replace(`{${"hospitalId"}}`, encodeURIComponent(String(hospitalId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (languageCode !== undefined) {
                localVarQueryParameter['languageCode'] = languageCode;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Create patient affiliation
         * @param {string} patientId 
         * @param {string} hospitalId 
         * @param {CreatePatientAffiliationCommand} [createPatientAffiliationCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PatientsPatientIdAffiliationsHospitalIdPost: async (patientId: string, hospitalId: string, createPatientAffiliationCommand?: CreatePatientAffiliationCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'patientId' is not null or undefined
            assertParamExists('apiV1PatientsPatientIdAffiliationsHospitalIdPost', 'patientId', patientId)
            // verify required parameter 'hospitalId' is not null or undefined
            assertParamExists('apiV1PatientsPatientIdAffiliationsHospitalIdPost', 'hospitalId', hospitalId)
            const localVarPath = `/api/v1/patients/{patientId}/affiliations/{hospitalId}`
                .replace(`{${"patientId"}}`, encodeURIComponent(String(patientId)))
                .replace(`{${"hospitalId"}}`, encodeURIComponent(String(hospitalId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(createPatientAffiliationCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update patient affiliation
         * @param {string} patientId 
         * @param {string} hospitalId 
         * @param {UpdatePatientAffiliationCommand} [updatePatientAffiliationCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PatientsPatientIdAffiliationsHospitalIdPut: async (patientId: string, hospitalId: string, updatePatientAffiliationCommand?: UpdatePatientAffiliationCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'patientId' is not null or undefined
            assertParamExists('apiV1PatientsPatientIdAffiliationsHospitalIdPut', 'patientId', patientId)
            // verify required parameter 'hospitalId' is not null or undefined
            assertParamExists('apiV1PatientsPatientIdAffiliationsHospitalIdPut', 'hospitalId', hospitalId)
            const localVarPath = `/api/v1/patients/{patientId}/affiliations/{hospitalId}`
                .replace(`{${"patientId"}}`, encodeURIComponent(String(patientId)))
                .replace(`{${"hospitalId"}}`, encodeURIComponent(String(hospitalId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(updatePatientAffiliationCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Reactivate patient affiliation
         * @param {string} patientId 
         * @param {string} hospitalId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PatientsPatientIdAffiliationsHospitalIdReactivatePut: async (patientId: string, hospitalId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'patientId' is not null or undefined
            assertParamExists('apiV1PatientsPatientIdAffiliationsHospitalIdReactivatePut', 'patientId', patientId)
            // verify required parameter 'hospitalId' is not null or undefined
            assertParamExists('apiV1PatientsPatientIdAffiliationsHospitalIdReactivatePut', 'hospitalId', hospitalId)
            const localVarPath = `/api/v1/patients/{patientId}/affiliations/{hospitalId}/reactivate`
                .replace(`{${"patientId"}}`, encodeURIComponent(String(patientId)))
                .replace(`{${"hospitalId"}}`, encodeURIComponent(String(hospitalId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete Patient.
         * @param {string} patientId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PatientsPatientIdDelete: async (patientId: string, isPermanent?: boolean, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'patientId' is not null or undefined
            assertParamExists('apiV1PatientsPatientIdDelete', 'patientId', patientId)
            const localVarPath = `/api/v1/patients/{patientId}`
                .replace(`{${"patientId"}}`, encodeURIComponent(String(patientId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (isPermanent !== undefined) {
                localVarQueryParameter['isPermanent'] = isPermanent;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get Patient.
         * @param {string} patientId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PatientsPatientIdGet: async (patientId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'patientId' is not null or undefined
            assertParamExists('apiV1PatientsPatientIdGet', 'patientId', patientId)
            const localVarPath = `/api/v1/patients/{patientId}`
                .replace(`{${"patientId"}}`, encodeURIComponent(String(patientId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update Patient.
         * @param {string} patientId 
         * @param {UpdatePatientCommand} [updatePatientCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PatientsPatientIdPut: async (patientId: string, updatePatientCommand?: UpdatePatientCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'patientId' is not null or undefined
            assertParamExists('apiV1PatientsPatientIdPut', 'patientId', patientId)
            const localVarPath = `/api/v1/patients/{patientId}`
                .replace(`{${"patientId"}}`, encodeURIComponent(String(patientId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(updatePatientCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Reactive Patient.
         * @param {string} patientId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PatientsPatientIdReactivatePut: async (patientId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'patientId' is not null or undefined
            assertParamExists('apiV1PatientsPatientIdReactivatePut', 'patientId', patientId)
            const localVarPath = `/api/v1/patients/{patientId}/reactivate`
                .replace(`{${"patientId"}}`, encodeURIComponent(String(patientId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Create a Patient.
         * @param {CreatePatientCommand} [createPatientCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PatientsPost: async (createPatientCommand?: CreatePatientCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/patients`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(createPatientCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get patient information for Patient walk-in feature
         * @param {GetPatientWalkInQuery} [getPatientWalkInQuery] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PatientsWalkinPost: async (getPatientWalkInQuery?: GetPatientWalkInQuery, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/patients/walkin`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(getPatientWalkInQuery, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * PatientsApi - functional programming interface
 * @export
 */
export const PatientsApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = PatientsApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Get all Patients.
         * @param {string} [hospitalId] 
         * @param {string} [id] 
         * @param {string} [fullname] 
         * @param {string} [email] 
         * @param {Gender} [gender] 
         * @param {Date} [dateOfBirth] 
         * @param {Date} [created] 
         * @param {boolean} [showHidden] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1PatientsGet(hospitalId?: string, id?: string, fullname?: string, email?: string, gender?: Gender, dateOfBirth?: Date, created?: Date, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<PatientsModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1PatientsGet(hospitalId, id, fullname, email, gender, dateOfBirth, created, showHidden, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Delete patient affiliation
         * @param {string} patientId 
         * @param {string} hospitalId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1PatientsPatientIdAffiliationsHospitalIdDelete(patientId: string, hospitalId: string, isPermanent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1PatientsPatientIdAffiliationsHospitalIdDelete(patientId, hospitalId, isPermanent, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get patientAffiliation by patient id and hospital id.
         * @param {string} patientId 
         * @param {string} hospitalId 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1PatientsPatientIdAffiliationsHospitalIdGet(patientId: string, hospitalId: string, languageCode?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<PatientAffiliationModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1PatientsPatientIdAffiliationsHospitalIdGet(patientId, hospitalId, languageCode, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Create patient affiliation
         * @param {string} patientId 
         * @param {string} hospitalId 
         * @param {CreatePatientAffiliationCommand} [createPatientAffiliationCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1PatientsPatientIdAffiliationsHospitalIdPost(patientId: string, hospitalId: string, createPatientAffiliationCommand?: CreatePatientAffiliationCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1PatientsPatientIdAffiliationsHospitalIdPost(patientId, hospitalId, createPatientAffiliationCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Update patient affiliation
         * @param {string} patientId 
         * @param {string} hospitalId 
         * @param {UpdatePatientAffiliationCommand} [updatePatientAffiliationCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1PatientsPatientIdAffiliationsHospitalIdPut(patientId: string, hospitalId: string, updatePatientAffiliationCommand?: UpdatePatientAffiliationCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1PatientsPatientIdAffiliationsHospitalIdPut(patientId, hospitalId, updatePatientAffiliationCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Reactivate patient affiliation
         * @param {string} patientId 
         * @param {string} hospitalId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1PatientsPatientIdAffiliationsHospitalIdReactivatePut(patientId: string, hospitalId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1PatientsPatientIdAffiliationsHospitalIdReactivatePut(patientId, hospitalId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Delete Patient.
         * @param {string} patientId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1PatientsPatientIdDelete(patientId: string, isPermanent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1PatientsPatientIdDelete(patientId, isPermanent, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get Patient.
         * @param {string} patientId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1PatientsPatientIdGet(patientId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<PatientModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1PatientsPatientIdGet(patientId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Update Patient.
         * @param {string} patientId 
         * @param {UpdatePatientCommand} [updatePatientCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1PatientsPatientIdPut(patientId: string, updatePatientCommand?: UpdatePatientCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<PatientModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1PatientsPatientIdPut(patientId, updatePatientCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Reactive Patient.
         * @param {string} patientId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1PatientsPatientIdReactivatePut(patientId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1PatientsPatientIdReactivatePut(patientId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Create a Patient.
         * @param {CreatePatientCommand} [createPatientCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1PatientsPost(createPatientCommand?: CreatePatientCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<PatientModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1PatientsPost(createPatientCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get patient information for Patient walk-in feature
         * @param {GetPatientWalkInQuery} [getPatientWalkInQuery] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1PatientsWalkinPost(getPatientWalkInQuery?: GetPatientWalkInQuery, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<PatientWalkInModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1PatientsWalkinPost(getPatientWalkInQuery, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * PatientsApi - factory interface
 * @export
 */
export const PatientsApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = PatientsApiFp(configuration)
    return {
        /**
         * 
         * @summary Get all Patients.
         * @param {string} [hospitalId] 
         * @param {string} [id] 
         * @param {string} [fullname] 
         * @param {string} [email] 
         * @param {Gender} [gender] 
         * @param {Date} [dateOfBirth] 
         * @param {Date} [created] 
         * @param {boolean} [showHidden] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PatientsGet(hospitalId?: string, id?: string, fullname?: string, email?: string, gender?: Gender, dateOfBirth?: Date, created?: Date, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<PatientsModel> {
            return localVarFp.apiV1PatientsGet(hospitalId, id, fullname, email, gender, dateOfBirth, created, showHidden, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete patient affiliation
         * @param {string} patientId 
         * @param {string} hospitalId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PatientsPatientIdAffiliationsHospitalIdDelete(patientId: string, hospitalId: string, isPermanent?: boolean, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1PatientsPatientIdAffiliationsHospitalIdDelete(patientId, hospitalId, isPermanent, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get patientAffiliation by patient id and hospital id.
         * @param {string} patientId 
         * @param {string} hospitalId 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PatientsPatientIdAffiliationsHospitalIdGet(patientId: string, hospitalId: string, languageCode?: string, options?: any): AxiosPromise<PatientAffiliationModel> {
            return localVarFp.apiV1PatientsPatientIdAffiliationsHospitalIdGet(patientId, hospitalId, languageCode, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Create patient affiliation
         * @param {string} patientId 
         * @param {string} hospitalId 
         * @param {CreatePatientAffiliationCommand} [createPatientAffiliationCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PatientsPatientIdAffiliationsHospitalIdPost(patientId: string, hospitalId: string, createPatientAffiliationCommand?: CreatePatientAffiliationCommand, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1PatientsPatientIdAffiliationsHospitalIdPost(patientId, hospitalId, createPatientAffiliationCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update patient affiliation
         * @param {string} patientId 
         * @param {string} hospitalId 
         * @param {UpdatePatientAffiliationCommand} [updatePatientAffiliationCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PatientsPatientIdAffiliationsHospitalIdPut(patientId: string, hospitalId: string, updatePatientAffiliationCommand?: UpdatePatientAffiliationCommand, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1PatientsPatientIdAffiliationsHospitalIdPut(patientId, hospitalId, updatePatientAffiliationCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Reactivate patient affiliation
         * @param {string} patientId 
         * @param {string} hospitalId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PatientsPatientIdAffiliationsHospitalIdReactivatePut(patientId: string, hospitalId: string, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1PatientsPatientIdAffiliationsHospitalIdReactivatePut(patientId, hospitalId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete Patient.
         * @param {string} patientId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PatientsPatientIdDelete(patientId: string, isPermanent?: boolean, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1PatientsPatientIdDelete(patientId, isPermanent, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get Patient.
         * @param {string} patientId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PatientsPatientIdGet(patientId: string, options?: any): AxiosPromise<PatientModel> {
            return localVarFp.apiV1PatientsPatientIdGet(patientId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update Patient.
         * @param {string} patientId 
         * @param {UpdatePatientCommand} [updatePatientCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PatientsPatientIdPut(patientId: string, updatePatientCommand?: UpdatePatientCommand, options?: any): AxiosPromise<PatientModel> {
            return localVarFp.apiV1PatientsPatientIdPut(patientId, updatePatientCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Reactive Patient.
         * @param {string} patientId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PatientsPatientIdReactivatePut(patientId: string, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1PatientsPatientIdReactivatePut(patientId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Create a Patient.
         * @param {CreatePatientCommand} [createPatientCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PatientsPost(createPatientCommand?: CreatePatientCommand, options?: any): AxiosPromise<PatientModel> {
            return localVarFp.apiV1PatientsPost(createPatientCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get patient information for Patient walk-in feature
         * @param {GetPatientWalkInQuery} [getPatientWalkInQuery] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PatientsWalkinPost(getPatientWalkInQuery?: GetPatientWalkInQuery, options?: any): AxiosPromise<PatientWalkInModel> {
            return localVarFp.apiV1PatientsWalkinPost(getPatientWalkInQuery, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for apiV1PatientsGet operation in PatientsApi.
 * @export
 * @interface PatientsApiApiV1PatientsGetRequest
 */
export interface PatientsApiApiV1PatientsGetRequest {
    /**
     * 
     * @type {string}
     * @memberof PatientsApiApiV1PatientsGet
     */
    readonly hospitalId?: string

    /**
     * 
     * @type {string}
     * @memberof PatientsApiApiV1PatientsGet
     */
    readonly id?: string

    /**
     * 
     * @type {string}
     * @memberof PatientsApiApiV1PatientsGet
     */
    readonly fullname?: string

    /**
     * 
     * @type {string}
     * @memberof PatientsApiApiV1PatientsGet
     */
    readonly email?: string

    /**
     * 
     * @type {Gender}
     * @memberof PatientsApiApiV1PatientsGet
     */
    readonly gender?: Gender

    /**
     * 
     * @type {Date}
     * @memberof PatientsApiApiV1PatientsGet
     */
    readonly dateOfBirth?: Date

    /**
     * 
     * @type {Date}
     * @memberof PatientsApiApiV1PatientsGet
     */
    readonly created?: Date

    /**
     * 
     * @type {boolean}
     * @memberof PatientsApiApiV1PatientsGet
     */
    readonly showHidden?: boolean

    /**
     * 
     * @type {number}
     * @memberof PatientsApiApiV1PatientsGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof PatientsApiApiV1PatientsGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof PatientsApiApiV1PatientsGet
     */
    readonly lastRetrieved?: Date
}

/**
 * Request parameters for apiV1PatientsPatientIdAffiliationsHospitalIdDelete operation in PatientsApi.
 * @export
 * @interface PatientsApiApiV1PatientsPatientIdAffiliationsHospitalIdDeleteRequest
 */
export interface PatientsApiApiV1PatientsPatientIdAffiliationsHospitalIdDeleteRequest {
    /**
     * 
     * @type {string}
     * @memberof PatientsApiApiV1PatientsPatientIdAffiliationsHospitalIdDelete
     */
    readonly patientId: string

    /**
     * 
     * @type {string}
     * @memberof PatientsApiApiV1PatientsPatientIdAffiliationsHospitalIdDelete
     */
    readonly hospitalId: string

    /**
     * 
     * @type {boolean}
     * @memberof PatientsApiApiV1PatientsPatientIdAffiliationsHospitalIdDelete
     */
    readonly isPermanent?: boolean
}

/**
 * Request parameters for apiV1PatientsPatientIdAffiliationsHospitalIdGet operation in PatientsApi.
 * @export
 * @interface PatientsApiApiV1PatientsPatientIdAffiliationsHospitalIdGetRequest
 */
export interface PatientsApiApiV1PatientsPatientIdAffiliationsHospitalIdGetRequest {
    /**
     * 
     * @type {string}
     * @memberof PatientsApiApiV1PatientsPatientIdAffiliationsHospitalIdGet
     */
    readonly patientId: string

    /**
     * 
     * @type {string}
     * @memberof PatientsApiApiV1PatientsPatientIdAffiliationsHospitalIdGet
     */
    readonly hospitalId: string

    /**
     * 
     * @type {string}
     * @memberof PatientsApiApiV1PatientsPatientIdAffiliationsHospitalIdGet
     */
    readonly languageCode?: string
}

/**
 * Request parameters for apiV1PatientsPatientIdAffiliationsHospitalIdPost operation in PatientsApi.
 * @export
 * @interface PatientsApiApiV1PatientsPatientIdAffiliationsHospitalIdPostRequest
 */
export interface PatientsApiApiV1PatientsPatientIdAffiliationsHospitalIdPostRequest {
    /**
     * 
     * @type {string}
     * @memberof PatientsApiApiV1PatientsPatientIdAffiliationsHospitalIdPost
     */
    readonly patientId: string

    /**
     * 
     * @type {string}
     * @memberof PatientsApiApiV1PatientsPatientIdAffiliationsHospitalIdPost
     */
    readonly hospitalId: string

    /**
     * 
     * @type {CreatePatientAffiliationCommand}
     * @memberof PatientsApiApiV1PatientsPatientIdAffiliationsHospitalIdPost
     */
    readonly createPatientAffiliationCommand?: CreatePatientAffiliationCommand
}

/**
 * Request parameters for apiV1PatientsPatientIdAffiliationsHospitalIdPut operation in PatientsApi.
 * @export
 * @interface PatientsApiApiV1PatientsPatientIdAffiliationsHospitalIdPutRequest
 */
export interface PatientsApiApiV1PatientsPatientIdAffiliationsHospitalIdPutRequest {
    /**
     * 
     * @type {string}
     * @memberof PatientsApiApiV1PatientsPatientIdAffiliationsHospitalIdPut
     */
    readonly patientId: string

    /**
     * 
     * @type {string}
     * @memberof PatientsApiApiV1PatientsPatientIdAffiliationsHospitalIdPut
     */
    readonly hospitalId: string

    /**
     * 
     * @type {UpdatePatientAffiliationCommand}
     * @memberof PatientsApiApiV1PatientsPatientIdAffiliationsHospitalIdPut
     */
    readonly updatePatientAffiliationCommand?: UpdatePatientAffiliationCommand
}

/**
 * Request parameters for apiV1PatientsPatientIdAffiliationsHospitalIdReactivatePut operation in PatientsApi.
 * @export
 * @interface PatientsApiApiV1PatientsPatientIdAffiliationsHospitalIdReactivatePutRequest
 */
export interface PatientsApiApiV1PatientsPatientIdAffiliationsHospitalIdReactivatePutRequest {
    /**
     * 
     * @type {string}
     * @memberof PatientsApiApiV1PatientsPatientIdAffiliationsHospitalIdReactivatePut
     */
    readonly patientId: string

    /**
     * 
     * @type {string}
     * @memberof PatientsApiApiV1PatientsPatientIdAffiliationsHospitalIdReactivatePut
     */
    readonly hospitalId: string
}

/**
 * Request parameters for apiV1PatientsPatientIdDelete operation in PatientsApi.
 * @export
 * @interface PatientsApiApiV1PatientsPatientIdDeleteRequest
 */
export interface PatientsApiApiV1PatientsPatientIdDeleteRequest {
    /**
     * 
     * @type {string}
     * @memberof PatientsApiApiV1PatientsPatientIdDelete
     */
    readonly patientId: string

    /**
     * 
     * @type {boolean}
     * @memberof PatientsApiApiV1PatientsPatientIdDelete
     */
    readonly isPermanent?: boolean
}

/**
 * Request parameters for apiV1PatientsPatientIdGet operation in PatientsApi.
 * @export
 * @interface PatientsApiApiV1PatientsPatientIdGetRequest
 */
export interface PatientsApiApiV1PatientsPatientIdGetRequest {
    /**
     * 
     * @type {string}
     * @memberof PatientsApiApiV1PatientsPatientIdGet
     */
    readonly patientId: string
}

/**
 * Request parameters for apiV1PatientsPatientIdPut operation in PatientsApi.
 * @export
 * @interface PatientsApiApiV1PatientsPatientIdPutRequest
 */
export interface PatientsApiApiV1PatientsPatientIdPutRequest {
    /**
     * 
     * @type {string}
     * @memberof PatientsApiApiV1PatientsPatientIdPut
     */
    readonly patientId: string

    /**
     * 
     * @type {UpdatePatientCommand}
     * @memberof PatientsApiApiV1PatientsPatientIdPut
     */
    readonly updatePatientCommand?: UpdatePatientCommand
}

/**
 * Request parameters for apiV1PatientsPatientIdReactivatePut operation in PatientsApi.
 * @export
 * @interface PatientsApiApiV1PatientsPatientIdReactivatePutRequest
 */
export interface PatientsApiApiV1PatientsPatientIdReactivatePutRequest {
    /**
     * 
     * @type {string}
     * @memberof PatientsApiApiV1PatientsPatientIdReactivatePut
     */
    readonly patientId: string
}

/**
 * Request parameters for apiV1PatientsPost operation in PatientsApi.
 * @export
 * @interface PatientsApiApiV1PatientsPostRequest
 */
export interface PatientsApiApiV1PatientsPostRequest {
    /**
     * 
     * @type {CreatePatientCommand}
     * @memberof PatientsApiApiV1PatientsPost
     */
    readonly createPatientCommand?: CreatePatientCommand
}

/**
 * Request parameters for apiV1PatientsWalkinPost operation in PatientsApi.
 * @export
 * @interface PatientsApiApiV1PatientsWalkinPostRequest
 */
export interface PatientsApiApiV1PatientsWalkinPostRequest {
    /**
     * 
     * @type {GetPatientWalkInQuery}
     * @memberof PatientsApiApiV1PatientsWalkinPost
     */
    readonly getPatientWalkInQuery?: GetPatientWalkInQuery
}

/**
 * PatientsApi - object-oriented interface
 * @export
 * @class PatientsApi
 * @extends {BaseAPI}
 */
export class PatientsApi extends BaseAPI {
    /**
     * 
     * @summary Get all Patients.
     * @param {PatientsApiApiV1PatientsGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PatientsApi
     */
    public apiV1PatientsGet(requestParameters: PatientsApiApiV1PatientsGetRequest = {}, options?: AxiosRequestConfig) {
        return PatientsApiFp(this.configuration).apiV1PatientsGet(requestParameters.hospitalId, requestParameters.id, requestParameters.fullname, requestParameters.email, requestParameters.gender, requestParameters.dateOfBirth, requestParameters.created, requestParameters.showHidden, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Delete patient affiliation
     * @param {PatientsApiApiV1PatientsPatientIdAffiliationsHospitalIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PatientsApi
     */
    public apiV1PatientsPatientIdAffiliationsHospitalIdDelete(requestParameters: PatientsApiApiV1PatientsPatientIdAffiliationsHospitalIdDeleteRequest, options?: AxiosRequestConfig) {
        return PatientsApiFp(this.configuration).apiV1PatientsPatientIdAffiliationsHospitalIdDelete(requestParameters.patientId, requestParameters.hospitalId, requestParameters.isPermanent, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get patientAffiliation by patient id and hospital id.
     * @param {PatientsApiApiV1PatientsPatientIdAffiliationsHospitalIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PatientsApi
     */
    public apiV1PatientsPatientIdAffiliationsHospitalIdGet(requestParameters: PatientsApiApiV1PatientsPatientIdAffiliationsHospitalIdGetRequest, options?: AxiosRequestConfig) {
        return PatientsApiFp(this.configuration).apiV1PatientsPatientIdAffiliationsHospitalIdGet(requestParameters.patientId, requestParameters.hospitalId, requestParameters.languageCode, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Create patient affiliation
     * @param {PatientsApiApiV1PatientsPatientIdAffiliationsHospitalIdPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PatientsApi
     */
    public apiV1PatientsPatientIdAffiliationsHospitalIdPost(requestParameters: PatientsApiApiV1PatientsPatientIdAffiliationsHospitalIdPostRequest, options?: AxiosRequestConfig) {
        return PatientsApiFp(this.configuration).apiV1PatientsPatientIdAffiliationsHospitalIdPost(requestParameters.patientId, requestParameters.hospitalId, requestParameters.createPatientAffiliationCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update patient affiliation
     * @param {PatientsApiApiV1PatientsPatientIdAffiliationsHospitalIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PatientsApi
     */
    public apiV1PatientsPatientIdAffiliationsHospitalIdPut(requestParameters: PatientsApiApiV1PatientsPatientIdAffiliationsHospitalIdPutRequest, options?: AxiosRequestConfig) {
        return PatientsApiFp(this.configuration).apiV1PatientsPatientIdAffiliationsHospitalIdPut(requestParameters.patientId, requestParameters.hospitalId, requestParameters.updatePatientAffiliationCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Reactivate patient affiliation
     * @param {PatientsApiApiV1PatientsPatientIdAffiliationsHospitalIdReactivatePutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PatientsApi
     */
    public apiV1PatientsPatientIdAffiliationsHospitalIdReactivatePut(requestParameters: PatientsApiApiV1PatientsPatientIdAffiliationsHospitalIdReactivatePutRequest, options?: AxiosRequestConfig) {
        return PatientsApiFp(this.configuration).apiV1PatientsPatientIdAffiliationsHospitalIdReactivatePut(requestParameters.patientId, requestParameters.hospitalId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Delete Patient.
     * @param {PatientsApiApiV1PatientsPatientIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PatientsApi
     */
    public apiV1PatientsPatientIdDelete(requestParameters: PatientsApiApiV1PatientsPatientIdDeleteRequest, options?: AxiosRequestConfig) {
        return PatientsApiFp(this.configuration).apiV1PatientsPatientIdDelete(requestParameters.patientId, requestParameters.isPermanent, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get Patient.
     * @param {PatientsApiApiV1PatientsPatientIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PatientsApi
     */
    public apiV1PatientsPatientIdGet(requestParameters: PatientsApiApiV1PatientsPatientIdGetRequest, options?: AxiosRequestConfig) {
        return PatientsApiFp(this.configuration).apiV1PatientsPatientIdGet(requestParameters.patientId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update Patient.
     * @param {PatientsApiApiV1PatientsPatientIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PatientsApi
     */
    public apiV1PatientsPatientIdPut(requestParameters: PatientsApiApiV1PatientsPatientIdPutRequest, options?: AxiosRequestConfig) {
        return PatientsApiFp(this.configuration).apiV1PatientsPatientIdPut(requestParameters.patientId, requestParameters.updatePatientCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Reactive Patient.
     * @param {PatientsApiApiV1PatientsPatientIdReactivatePutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PatientsApi
     */
    public apiV1PatientsPatientIdReactivatePut(requestParameters: PatientsApiApiV1PatientsPatientIdReactivatePutRequest, options?: AxiosRequestConfig) {
        return PatientsApiFp(this.configuration).apiV1PatientsPatientIdReactivatePut(requestParameters.patientId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Create a Patient.
     * @param {PatientsApiApiV1PatientsPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PatientsApi
     */
    public apiV1PatientsPost(requestParameters: PatientsApiApiV1PatientsPostRequest = {}, options?: AxiosRequestConfig) {
        return PatientsApiFp(this.configuration).apiV1PatientsPost(requestParameters.createPatientCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get patient information for Patient walk-in feature
     * @param {PatientsApiApiV1PatientsWalkinPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PatientsApi
     */
    public apiV1PatientsWalkinPost(requestParameters: PatientsApiApiV1PatientsWalkinPostRequest = {}, options?: AxiosRequestConfig) {
        return PatientsApiFp(this.configuration).apiV1PatientsWalkinPost(requestParameters.getPatientWalkInQuery, options).then((request) => request(this.axios, this.basePath));
    }
}
