/* tslint:disable */
/* eslint-disable */
/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import globalAxios, { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '../base';
// @ts-ignore
import { CreateSurveyFormCommand } from '../models';
// @ts-ignore
import { ProblemDetails } from '../models';
// @ts-ignore
import { SetHospitalIntoSurveyFormCommand } from '../models';
// @ts-ignore
import { SurveyFormModel } from '../models';
// @ts-ignore
import { SurveyFormStatus } from '../models';
// @ts-ignore
import { SurveyFormsModel } from '../models';
// @ts-ignore
import { UpdateSurveyFormCommand } from '../models';
/**
 * SurveyFormsApi - axios parameter creator
 * @export
 */
export const SurveyFormsApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Get survey forms
         * @param {string} [id] 
         * @param {string} [hospitalId] 
         * @param {string} [name] 
         * @param {string} [languageCode] 
         * @param {boolean} [showHidden] 
         * @param {boolean} [isShared] 
         * @param {SurveyFormStatus} [status] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SurveyformsGet: async (id?: string, hospitalId?: string, name?: string, languageCode?: string, showHidden?: boolean, isShared?: boolean, status?: SurveyFormStatus, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/surveyforms`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (id !== undefined) {
                localVarQueryParameter['Id'] = id;
            }

            if (hospitalId !== undefined) {
                localVarQueryParameter['HospitalId'] = hospitalId;
            }

            if (name !== undefined) {
                localVarQueryParameter['Name'] = name;
            }

            if (languageCode !== undefined) {
                localVarQueryParameter['LanguageCode'] = languageCode;
            }

            if (showHidden !== undefined) {
                localVarQueryParameter['ShowHidden'] = showHidden;
            }

            if (isShared !== undefined) {
                localVarQueryParameter['IsShared'] = isShared;
            }

            if (status !== undefined) {
                localVarQueryParameter['Status'] = status;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Create survey form
         * @param {CreateSurveyFormCommand} [createSurveyFormCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SurveyformsPost: async (createSurveyFormCommand?: CreateSurveyFormCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/surveyforms`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(createSurveyFormCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete survey form by Id
         * @param {string} surveyFormId 
         * @param {string} [languageCode] 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SurveyformsSurveyFormIdDelete: async (surveyFormId: string, languageCode?: string, isPermanent?: boolean, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'surveyFormId' is not null or undefined
            assertParamExists('apiV1SurveyformsSurveyFormIdDelete', 'surveyFormId', surveyFormId)
            const localVarPath = `/api/v1/surveyforms/{surveyFormId}`
                .replace(`{${"surveyFormId"}}`, encodeURIComponent(String(surveyFormId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (languageCode !== undefined) {
                localVarQueryParameter['languageCode'] = languageCode;
            }

            if (isPermanent !== undefined) {
                localVarQueryParameter['isPermanent'] = isPermanent;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get survey form by Id
         * @param {string} surveyFormId 
         * @param {string} [languageCode] 
         * @param {string} [hospitalId] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SurveyformsSurveyFormIdGet: async (surveyFormId: string, languageCode?: string, hospitalId?: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'surveyFormId' is not null or undefined
            assertParamExists('apiV1SurveyformsSurveyFormIdGet', 'surveyFormId', surveyFormId)
            const localVarPath = `/api/v1/surveyforms/{surveyFormId}`
                .replace(`{${"surveyFormId"}}`, encodeURIComponent(String(surveyFormId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (languageCode !== undefined) {
                localVarQueryParameter['languageCode'] = languageCode;
            }

            if (hospitalId !== undefined) {
                localVarQueryParameter['hospitalId'] = hospitalId;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Remove hospital from surveyFormAffiliations
         * @param {string} surveyFormId 
         * @param {string} hospitalId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SurveyformsSurveyFormIdHospitalsHospitalIdDelete: async (surveyFormId: string, hospitalId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'surveyFormId' is not null or undefined
            assertParamExists('apiV1SurveyformsSurveyFormIdHospitalsHospitalIdDelete', 'surveyFormId', surveyFormId)
            // verify required parameter 'hospitalId' is not null or undefined
            assertParamExists('apiV1SurveyformsSurveyFormIdHospitalsHospitalIdDelete', 'hospitalId', hospitalId)
            const localVarPath = `/api/v1/surveyforms/{surveyFormId}/hospitals/{hospitalId}`
                .replace(`{${"surveyFormId"}}`, encodeURIComponent(String(surveyFormId)))
                .replace(`{${"hospitalId"}}`, encodeURIComponent(String(hospitalId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Add hospital into surveyFormAffiliation.
         * @param {string} surveyFormId 
         * @param {string} hospitalId 
         * @param {SetHospitalIntoSurveyFormCommand} [setHospitalIntoSurveyFormCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SurveyformsSurveyFormIdHospitalsHospitalIdPost: async (surveyFormId: string, hospitalId: string, setHospitalIntoSurveyFormCommand?: SetHospitalIntoSurveyFormCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'surveyFormId' is not null or undefined
            assertParamExists('apiV1SurveyformsSurveyFormIdHospitalsHospitalIdPost', 'surveyFormId', surveyFormId)
            // verify required parameter 'hospitalId' is not null or undefined
            assertParamExists('apiV1SurveyformsSurveyFormIdHospitalsHospitalIdPost', 'hospitalId', hospitalId)
            const localVarPath = `/api/v1/surveyforms/{surveyFormId}/hospitals/{hospitalId}`
                .replace(`{${"surveyFormId"}}`, encodeURIComponent(String(surveyFormId)))
                .replace(`{${"hospitalId"}}`, encodeURIComponent(String(hospitalId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(setHospitalIntoSurveyFormCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update survey form
         * @param {string} surveyFormId 
         * @param {UpdateSurveyFormCommand} [updateSurveyFormCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SurveyformsSurveyFormIdPut: async (surveyFormId: string, updateSurveyFormCommand?: UpdateSurveyFormCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'surveyFormId' is not null or undefined
            assertParamExists('apiV1SurveyformsSurveyFormIdPut', 'surveyFormId', surveyFormId)
            const localVarPath = `/api/v1/surveyforms/{surveyFormId}`
                .replace(`{${"surveyFormId"}}`, encodeURIComponent(String(surveyFormId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(updateSurveyFormCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Reactivate surveyForm
         * @param {string} surveyFormId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SurveyformsSurveyFormIdReactivatePut: async (surveyFormId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'surveyFormId' is not null or undefined
            assertParamExists('apiV1SurveyformsSurveyFormIdReactivatePut', 'surveyFormId', surveyFormId)
            const localVarPath = `/api/v1/surveyforms/{surveyFormId}/reactivate`
                .replace(`{${"surveyFormId"}}`, encodeURIComponent(String(surveyFormId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * SurveyFormsApi - functional programming interface
 * @export
 */
export const SurveyFormsApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = SurveyFormsApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Get survey forms
         * @param {string} [id] 
         * @param {string} [hospitalId] 
         * @param {string} [name] 
         * @param {string} [languageCode] 
         * @param {boolean} [showHidden] 
         * @param {boolean} [isShared] 
         * @param {SurveyFormStatus} [status] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1SurveyformsGet(id?: string, hospitalId?: string, name?: string, languageCode?: string, showHidden?: boolean, isShared?: boolean, status?: SurveyFormStatus, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SurveyFormsModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1SurveyformsGet(id, hospitalId, name, languageCode, showHidden, isShared, status, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Create survey form
         * @param {CreateSurveyFormCommand} [createSurveyFormCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1SurveyformsPost(createSurveyFormCommand?: CreateSurveyFormCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SurveyFormModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1SurveyformsPost(createSurveyFormCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Delete survey form by Id
         * @param {string} surveyFormId 
         * @param {string} [languageCode] 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1SurveyformsSurveyFormIdDelete(surveyFormId: string, languageCode?: string, isPermanent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1SurveyformsSurveyFormIdDelete(surveyFormId, languageCode, isPermanent, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get survey form by Id
         * @param {string} surveyFormId 
         * @param {string} [languageCode] 
         * @param {string} [hospitalId] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1SurveyformsSurveyFormIdGet(surveyFormId: string, languageCode?: string, hospitalId?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SurveyFormModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1SurveyformsSurveyFormIdGet(surveyFormId, languageCode, hospitalId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Remove hospital from surveyFormAffiliations
         * @param {string} surveyFormId 
         * @param {string} hospitalId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1SurveyformsSurveyFormIdHospitalsHospitalIdDelete(surveyFormId: string, hospitalId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1SurveyformsSurveyFormIdHospitalsHospitalIdDelete(surveyFormId, hospitalId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Add hospital into surveyFormAffiliation.
         * @param {string} surveyFormId 
         * @param {string} hospitalId 
         * @param {SetHospitalIntoSurveyFormCommand} [setHospitalIntoSurveyFormCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1SurveyformsSurveyFormIdHospitalsHospitalIdPost(surveyFormId: string, hospitalId: string, setHospitalIntoSurveyFormCommand?: SetHospitalIntoSurveyFormCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1SurveyformsSurveyFormIdHospitalsHospitalIdPost(surveyFormId, hospitalId, setHospitalIntoSurveyFormCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Update survey form
         * @param {string} surveyFormId 
         * @param {UpdateSurveyFormCommand} [updateSurveyFormCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1SurveyformsSurveyFormIdPut(surveyFormId: string, updateSurveyFormCommand?: UpdateSurveyFormCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SurveyFormModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1SurveyformsSurveyFormIdPut(surveyFormId, updateSurveyFormCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Reactivate surveyForm
         * @param {string} surveyFormId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1SurveyformsSurveyFormIdReactivatePut(surveyFormId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1SurveyformsSurveyFormIdReactivatePut(surveyFormId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * SurveyFormsApi - factory interface
 * @export
 */
export const SurveyFormsApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = SurveyFormsApiFp(configuration)
    return {
        /**
         * 
         * @summary Get survey forms
         * @param {string} [id] 
         * @param {string} [hospitalId] 
         * @param {string} [name] 
         * @param {string} [languageCode] 
         * @param {boolean} [showHidden] 
         * @param {boolean} [isShared] 
         * @param {SurveyFormStatus} [status] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SurveyformsGet(id?: string, hospitalId?: string, name?: string, languageCode?: string, showHidden?: boolean, isShared?: boolean, status?: SurveyFormStatus, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<SurveyFormsModel> {
            return localVarFp.apiV1SurveyformsGet(id, hospitalId, name, languageCode, showHidden, isShared, status, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Create survey form
         * @param {CreateSurveyFormCommand} [createSurveyFormCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SurveyformsPost(createSurveyFormCommand?: CreateSurveyFormCommand, options?: any): AxiosPromise<SurveyFormModel> {
            return localVarFp.apiV1SurveyformsPost(createSurveyFormCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete survey form by Id
         * @param {string} surveyFormId 
         * @param {string} [languageCode] 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SurveyformsSurveyFormIdDelete(surveyFormId: string, languageCode?: string, isPermanent?: boolean, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1SurveyformsSurveyFormIdDelete(surveyFormId, languageCode, isPermanent, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get survey form by Id
         * @param {string} surveyFormId 
         * @param {string} [languageCode] 
         * @param {string} [hospitalId] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SurveyformsSurveyFormIdGet(surveyFormId: string, languageCode?: string, hospitalId?: string, options?: any): AxiosPromise<SurveyFormModel> {
            return localVarFp.apiV1SurveyformsSurveyFormIdGet(surveyFormId, languageCode, hospitalId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Remove hospital from surveyFormAffiliations
         * @param {string} surveyFormId 
         * @param {string} hospitalId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SurveyformsSurveyFormIdHospitalsHospitalIdDelete(surveyFormId: string, hospitalId: string, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1SurveyformsSurveyFormIdHospitalsHospitalIdDelete(surveyFormId, hospitalId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Add hospital into surveyFormAffiliation.
         * @param {string} surveyFormId 
         * @param {string} hospitalId 
         * @param {SetHospitalIntoSurveyFormCommand} [setHospitalIntoSurveyFormCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SurveyformsSurveyFormIdHospitalsHospitalIdPost(surveyFormId: string, hospitalId: string, setHospitalIntoSurveyFormCommand?: SetHospitalIntoSurveyFormCommand, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1SurveyformsSurveyFormIdHospitalsHospitalIdPost(surveyFormId, hospitalId, setHospitalIntoSurveyFormCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update survey form
         * @param {string} surveyFormId 
         * @param {UpdateSurveyFormCommand} [updateSurveyFormCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SurveyformsSurveyFormIdPut(surveyFormId: string, updateSurveyFormCommand?: UpdateSurveyFormCommand, options?: any): AxiosPromise<SurveyFormModel> {
            return localVarFp.apiV1SurveyformsSurveyFormIdPut(surveyFormId, updateSurveyFormCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Reactivate surveyForm
         * @param {string} surveyFormId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SurveyformsSurveyFormIdReactivatePut(surveyFormId: string, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1SurveyformsSurveyFormIdReactivatePut(surveyFormId, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for apiV1SurveyformsGet operation in SurveyFormsApi.
 * @export
 * @interface SurveyFormsApiApiV1SurveyformsGetRequest
 */
export interface SurveyFormsApiApiV1SurveyformsGetRequest {
    /**
     * 
     * @type {string}
     * @memberof SurveyFormsApiApiV1SurveyformsGet
     */
    readonly id?: string

    /**
     * 
     * @type {string}
     * @memberof SurveyFormsApiApiV1SurveyformsGet
     */
    readonly hospitalId?: string

    /**
     * 
     * @type {string}
     * @memberof SurveyFormsApiApiV1SurveyformsGet
     */
    readonly name?: string

    /**
     * 
     * @type {string}
     * @memberof SurveyFormsApiApiV1SurveyformsGet
     */
    readonly languageCode?: string

    /**
     * 
     * @type {boolean}
     * @memberof SurveyFormsApiApiV1SurveyformsGet
     */
    readonly showHidden?: boolean

    /**
     * 
     * @type {boolean}
     * @memberof SurveyFormsApiApiV1SurveyformsGet
     */
    readonly isShared?: boolean

    /**
     * 
     * @type {SurveyFormStatus}
     * @memberof SurveyFormsApiApiV1SurveyformsGet
     */
    readonly status?: SurveyFormStatus

    /**
     * 
     * @type {number}
     * @memberof SurveyFormsApiApiV1SurveyformsGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof SurveyFormsApiApiV1SurveyformsGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof SurveyFormsApiApiV1SurveyformsGet
     */
    readonly lastRetrieved?: Date
}

/**
 * Request parameters for apiV1SurveyformsPost operation in SurveyFormsApi.
 * @export
 * @interface SurveyFormsApiApiV1SurveyformsPostRequest
 */
export interface SurveyFormsApiApiV1SurveyformsPostRequest {
    /**
     * 
     * @type {CreateSurveyFormCommand}
     * @memberof SurveyFormsApiApiV1SurveyformsPost
     */
    readonly createSurveyFormCommand?: CreateSurveyFormCommand
}

/**
 * Request parameters for apiV1SurveyformsSurveyFormIdDelete operation in SurveyFormsApi.
 * @export
 * @interface SurveyFormsApiApiV1SurveyformsSurveyFormIdDeleteRequest
 */
export interface SurveyFormsApiApiV1SurveyformsSurveyFormIdDeleteRequest {
    /**
     * 
     * @type {string}
     * @memberof SurveyFormsApiApiV1SurveyformsSurveyFormIdDelete
     */
    readonly surveyFormId: string

    /**
     * 
     * @type {string}
     * @memberof SurveyFormsApiApiV1SurveyformsSurveyFormIdDelete
     */
    readonly languageCode?: string

    /**
     * 
     * @type {boolean}
     * @memberof SurveyFormsApiApiV1SurveyformsSurveyFormIdDelete
     */
    readonly isPermanent?: boolean
}

/**
 * Request parameters for apiV1SurveyformsSurveyFormIdGet operation in SurveyFormsApi.
 * @export
 * @interface SurveyFormsApiApiV1SurveyformsSurveyFormIdGetRequest
 */
export interface SurveyFormsApiApiV1SurveyformsSurveyFormIdGetRequest {
    /**
     * 
     * @type {string}
     * @memberof SurveyFormsApiApiV1SurveyformsSurveyFormIdGet
     */
    readonly surveyFormId: string

    /**
     * 
     * @type {string}
     * @memberof SurveyFormsApiApiV1SurveyformsSurveyFormIdGet
     */
    readonly languageCode?: string

    /**
     * 
     * @type {string}
     * @memberof SurveyFormsApiApiV1SurveyformsSurveyFormIdGet
     */
    readonly hospitalId?: string
}

/**
 * Request parameters for apiV1SurveyformsSurveyFormIdHospitalsHospitalIdDelete operation in SurveyFormsApi.
 * @export
 * @interface SurveyFormsApiApiV1SurveyformsSurveyFormIdHospitalsHospitalIdDeleteRequest
 */
export interface SurveyFormsApiApiV1SurveyformsSurveyFormIdHospitalsHospitalIdDeleteRequest {
    /**
     * 
     * @type {string}
     * @memberof SurveyFormsApiApiV1SurveyformsSurveyFormIdHospitalsHospitalIdDelete
     */
    readonly surveyFormId: string

    /**
     * 
     * @type {string}
     * @memberof SurveyFormsApiApiV1SurveyformsSurveyFormIdHospitalsHospitalIdDelete
     */
    readonly hospitalId: string
}

/**
 * Request parameters for apiV1SurveyformsSurveyFormIdHospitalsHospitalIdPost operation in SurveyFormsApi.
 * @export
 * @interface SurveyFormsApiApiV1SurveyformsSurveyFormIdHospitalsHospitalIdPostRequest
 */
export interface SurveyFormsApiApiV1SurveyformsSurveyFormIdHospitalsHospitalIdPostRequest {
    /**
     * 
     * @type {string}
     * @memberof SurveyFormsApiApiV1SurveyformsSurveyFormIdHospitalsHospitalIdPost
     */
    readonly surveyFormId: string

    /**
     * 
     * @type {string}
     * @memberof SurveyFormsApiApiV1SurveyformsSurveyFormIdHospitalsHospitalIdPost
     */
    readonly hospitalId: string

    /**
     * 
     * @type {SetHospitalIntoSurveyFormCommand}
     * @memberof SurveyFormsApiApiV1SurveyformsSurveyFormIdHospitalsHospitalIdPost
     */
    readonly setHospitalIntoSurveyFormCommand?: SetHospitalIntoSurveyFormCommand
}

/**
 * Request parameters for apiV1SurveyformsSurveyFormIdPut operation in SurveyFormsApi.
 * @export
 * @interface SurveyFormsApiApiV1SurveyformsSurveyFormIdPutRequest
 */
export interface SurveyFormsApiApiV1SurveyformsSurveyFormIdPutRequest {
    /**
     * 
     * @type {string}
     * @memberof SurveyFormsApiApiV1SurveyformsSurveyFormIdPut
     */
    readonly surveyFormId: string

    /**
     * 
     * @type {UpdateSurveyFormCommand}
     * @memberof SurveyFormsApiApiV1SurveyformsSurveyFormIdPut
     */
    readonly updateSurveyFormCommand?: UpdateSurveyFormCommand
}

/**
 * Request parameters for apiV1SurveyformsSurveyFormIdReactivatePut operation in SurveyFormsApi.
 * @export
 * @interface SurveyFormsApiApiV1SurveyformsSurveyFormIdReactivatePutRequest
 */
export interface SurveyFormsApiApiV1SurveyformsSurveyFormIdReactivatePutRequest {
    /**
     * 
     * @type {string}
     * @memberof SurveyFormsApiApiV1SurveyformsSurveyFormIdReactivatePut
     */
    readonly surveyFormId: string
}

/**
 * SurveyFormsApi - object-oriented interface
 * @export
 * @class SurveyFormsApi
 * @extends {BaseAPI}
 */
export class SurveyFormsApi extends BaseAPI {
    /**
     * 
     * @summary Get survey forms
     * @param {SurveyFormsApiApiV1SurveyformsGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SurveyFormsApi
     */
    public apiV1SurveyformsGet(requestParameters: SurveyFormsApiApiV1SurveyformsGetRequest = {}, options?: AxiosRequestConfig) {
        return SurveyFormsApiFp(this.configuration).apiV1SurveyformsGet(requestParameters.id, requestParameters.hospitalId, requestParameters.name, requestParameters.languageCode, requestParameters.showHidden, requestParameters.isShared, requestParameters.status, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Create survey form
     * @param {SurveyFormsApiApiV1SurveyformsPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SurveyFormsApi
     */
    public apiV1SurveyformsPost(requestParameters: SurveyFormsApiApiV1SurveyformsPostRequest = {}, options?: AxiosRequestConfig) {
        return SurveyFormsApiFp(this.configuration).apiV1SurveyformsPost(requestParameters.createSurveyFormCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Delete survey form by Id
     * @param {SurveyFormsApiApiV1SurveyformsSurveyFormIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SurveyFormsApi
     */
    public apiV1SurveyformsSurveyFormIdDelete(requestParameters: SurveyFormsApiApiV1SurveyformsSurveyFormIdDeleteRequest, options?: AxiosRequestConfig) {
        return SurveyFormsApiFp(this.configuration).apiV1SurveyformsSurveyFormIdDelete(requestParameters.surveyFormId, requestParameters.languageCode, requestParameters.isPermanent, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get survey form by Id
     * @param {SurveyFormsApiApiV1SurveyformsSurveyFormIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SurveyFormsApi
     */
    public apiV1SurveyformsSurveyFormIdGet(requestParameters: SurveyFormsApiApiV1SurveyformsSurveyFormIdGetRequest, options?: AxiosRequestConfig) {
        return SurveyFormsApiFp(this.configuration).apiV1SurveyformsSurveyFormIdGet(requestParameters.surveyFormId, requestParameters.languageCode, requestParameters.hospitalId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Remove hospital from surveyFormAffiliations
     * @param {SurveyFormsApiApiV1SurveyformsSurveyFormIdHospitalsHospitalIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SurveyFormsApi
     */
    public apiV1SurveyformsSurveyFormIdHospitalsHospitalIdDelete(requestParameters: SurveyFormsApiApiV1SurveyformsSurveyFormIdHospitalsHospitalIdDeleteRequest, options?: AxiosRequestConfig) {
        return SurveyFormsApiFp(this.configuration).apiV1SurveyformsSurveyFormIdHospitalsHospitalIdDelete(requestParameters.surveyFormId, requestParameters.hospitalId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Add hospital into surveyFormAffiliation.
     * @param {SurveyFormsApiApiV1SurveyformsSurveyFormIdHospitalsHospitalIdPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SurveyFormsApi
     */
    public apiV1SurveyformsSurveyFormIdHospitalsHospitalIdPost(requestParameters: SurveyFormsApiApiV1SurveyformsSurveyFormIdHospitalsHospitalIdPostRequest, options?: AxiosRequestConfig) {
        return SurveyFormsApiFp(this.configuration).apiV1SurveyformsSurveyFormIdHospitalsHospitalIdPost(requestParameters.surveyFormId, requestParameters.hospitalId, requestParameters.setHospitalIntoSurveyFormCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update survey form
     * @param {SurveyFormsApiApiV1SurveyformsSurveyFormIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SurveyFormsApi
     */
    public apiV1SurveyformsSurveyFormIdPut(requestParameters: SurveyFormsApiApiV1SurveyformsSurveyFormIdPutRequest, options?: AxiosRequestConfig) {
        return SurveyFormsApiFp(this.configuration).apiV1SurveyformsSurveyFormIdPut(requestParameters.surveyFormId, requestParameters.updateSurveyFormCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Reactivate surveyForm
     * @param {SurveyFormsApiApiV1SurveyformsSurveyFormIdReactivatePutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SurveyFormsApi
     */
    public apiV1SurveyformsSurveyFormIdReactivatePut(requestParameters: SurveyFormsApiApiV1SurveyformsSurveyFormIdReactivatePutRequest, options?: AxiosRequestConfig) {
        return SurveyFormsApiFp(this.configuration).apiV1SurveyformsSurveyFormIdReactivatePut(requestParameters.surveyFormId, options).then((request) => request(this.axios, this.basePath));
    }
}
