/* tslint:disable */
/* eslint-disable */
/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import globalAxios, { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '../base';
// @ts-ignore
import { PeriodUnits } from '../models';
// @ts-ignore
import { ProblemDetails } from '../models';
// @ts-ignore
import { SendEmailCommand } from '../models';
// @ts-ignore
import { SurveyResultModel } from '../models';
// @ts-ignore
import { SurveyResultsModel } from '../models';
/**
 * SurveyResultsApi - axios parameter creator
 * @export
 */
export const SurveyResultsApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Get survey results
         * @param {string} [id] 
         * @param {string} [hospitalId] 
         * @param {string} [surveyFormId] 
         * @param {string} [name] 
         * @param {string} [languageCode] 
         * @param {PeriodUnits} [periodUnit] 
         * @param {Date} [startDateTime] 
         * @param {Date} [endDateTime] 
         * @param {boolean} [isExternal] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SurveyresultsGet: async (id?: string, hospitalId?: string, surveyFormId?: string, name?: string, languageCode?: string, periodUnit?: PeriodUnits, startDateTime?: Date, endDateTime?: Date, isExternal?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/surveyresults`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (id !== undefined) {
                localVarQueryParameter['Id'] = id;
            }

            if (hospitalId !== undefined) {
                localVarQueryParameter['HospitalId'] = hospitalId;
            }

            if (surveyFormId !== undefined) {
                localVarQueryParameter['SurveyFormId'] = surveyFormId;
            }

            if (name !== undefined) {
                localVarQueryParameter['Name'] = name;
            }

            if (languageCode !== undefined) {
                localVarQueryParameter['LanguageCode'] = languageCode;
            }

            if (periodUnit !== undefined) {
                localVarQueryParameter['PeriodUnit'] = periodUnit;
            }

            if (startDateTime !== undefined) {
                localVarQueryParameter['StartDateTime'] = (startDateTime as any instanceof Date) ?
                    (startDateTime as any).toISOString() :
                    startDateTime;
            }

            if (endDateTime !== undefined) {
                localVarQueryParameter['EndDateTime'] = (endDateTime as any instanceof Date) ?
                    (endDateTime as any).toISOString() :
                    endDateTime;
            }

            if (isExternal !== undefined) {
                localVarQueryParameter['IsExternal'] = isExternal;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Send manual notification of target SurveyResult
         * @param {SendEmailCommand} [sendEmailCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SurveyresultsSendemailPost: async (sendEmailCommand?: SendEmailCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/surveyresults/sendemail`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(sendEmailCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete survey result
         * @param {string} surveyResultId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SurveyresultsSurveyResultIdDelete: async (surveyResultId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'surveyResultId' is not null or undefined
            assertParamExists('apiV1SurveyresultsSurveyResultIdDelete', 'surveyResultId', surveyResultId)
            const localVarPath = `/api/v1/surveyresults/{surveyResultId}`
                .replace(`{${"surveyResultId"}}`, encodeURIComponent(String(surveyResultId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get survey result by Id
         * @param {string} surveyResultId 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SurveyresultsSurveyResultIdGet: async (surveyResultId: string, languageCode?: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'surveyResultId' is not null or undefined
            assertParamExists('apiV1SurveyresultsSurveyResultIdGet', 'surveyResultId', surveyResultId)
            const localVarPath = `/api/v1/surveyresults/{surveyResultId}`
                .replace(`{${"surveyResultId"}}`, encodeURIComponent(String(surveyResultId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (languageCode !== undefined) {
                localVarQueryParameter['languageCode'] = languageCode;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * SurveyResultsApi - functional programming interface
 * @export
 */
export const SurveyResultsApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = SurveyResultsApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Get survey results
         * @param {string} [id] 
         * @param {string} [hospitalId] 
         * @param {string} [surveyFormId] 
         * @param {string} [name] 
         * @param {string} [languageCode] 
         * @param {PeriodUnits} [periodUnit] 
         * @param {Date} [startDateTime] 
         * @param {Date} [endDateTime] 
         * @param {boolean} [isExternal] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1SurveyresultsGet(id?: string, hospitalId?: string, surveyFormId?: string, name?: string, languageCode?: string, periodUnit?: PeriodUnits, startDateTime?: Date, endDateTime?: Date, isExternal?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SurveyResultsModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1SurveyresultsGet(id, hospitalId, surveyFormId, name, languageCode, periodUnit, startDateTime, endDateTime, isExternal, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Send manual notification of target SurveyResult
         * @param {SendEmailCommand} [sendEmailCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1SurveyresultsSendemailPost(sendEmailCommand?: SendEmailCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1SurveyresultsSendemailPost(sendEmailCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Delete survey result
         * @param {string} surveyResultId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1SurveyresultsSurveyResultIdDelete(surveyResultId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1SurveyresultsSurveyResultIdDelete(surveyResultId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get survey result by Id
         * @param {string} surveyResultId 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1SurveyresultsSurveyResultIdGet(surveyResultId: string, languageCode?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SurveyResultModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1SurveyresultsSurveyResultIdGet(surveyResultId, languageCode, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * SurveyResultsApi - factory interface
 * @export
 */
export const SurveyResultsApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = SurveyResultsApiFp(configuration)
    return {
        /**
         * 
         * @summary Get survey results
         * @param {string} [id] 
         * @param {string} [hospitalId] 
         * @param {string} [surveyFormId] 
         * @param {string} [name] 
         * @param {string} [languageCode] 
         * @param {PeriodUnits} [periodUnit] 
         * @param {Date} [startDateTime] 
         * @param {Date} [endDateTime] 
         * @param {boolean} [isExternal] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SurveyresultsGet(id?: string, hospitalId?: string, surveyFormId?: string, name?: string, languageCode?: string, periodUnit?: PeriodUnits, startDateTime?: Date, endDateTime?: Date, isExternal?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<SurveyResultsModel> {
            return localVarFp.apiV1SurveyresultsGet(id, hospitalId, surveyFormId, name, languageCode, periodUnit, startDateTime, endDateTime, isExternal, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Send manual notification of target SurveyResult
         * @param {SendEmailCommand} [sendEmailCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SurveyresultsSendemailPost(sendEmailCommand?: SendEmailCommand, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1SurveyresultsSendemailPost(sendEmailCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete survey result
         * @param {string} surveyResultId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SurveyresultsSurveyResultIdDelete(surveyResultId: string, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1SurveyresultsSurveyResultIdDelete(surveyResultId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get survey result by Id
         * @param {string} surveyResultId 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1SurveyresultsSurveyResultIdGet(surveyResultId: string, languageCode?: string, options?: any): AxiosPromise<SurveyResultModel> {
            return localVarFp.apiV1SurveyresultsSurveyResultIdGet(surveyResultId, languageCode, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for apiV1SurveyresultsGet operation in SurveyResultsApi.
 * @export
 * @interface SurveyResultsApiApiV1SurveyresultsGetRequest
 */
export interface SurveyResultsApiApiV1SurveyresultsGetRequest {
    /**
     * 
     * @type {string}
     * @memberof SurveyResultsApiApiV1SurveyresultsGet
     */
    readonly id?: string

    /**
     * 
     * @type {string}
     * @memberof SurveyResultsApiApiV1SurveyresultsGet
     */
    readonly hospitalId?: string

    /**
     * 
     * @type {string}
     * @memberof SurveyResultsApiApiV1SurveyresultsGet
     */
    readonly surveyFormId?: string

    /**
     * 
     * @type {string}
     * @memberof SurveyResultsApiApiV1SurveyresultsGet
     */
    readonly name?: string

    /**
     * 
     * @type {string}
     * @memberof SurveyResultsApiApiV1SurveyresultsGet
     */
    readonly languageCode?: string

    /**
     * 
     * @type {PeriodUnits}
     * @memberof SurveyResultsApiApiV1SurveyresultsGet
     */
    readonly periodUnit?: PeriodUnits

    /**
     * 
     * @type {Date}
     * @memberof SurveyResultsApiApiV1SurveyresultsGet
     */
    readonly startDateTime?: Date

    /**
     * 
     * @type {Date}
     * @memberof SurveyResultsApiApiV1SurveyresultsGet
     */
    readonly endDateTime?: Date

    /**
     * 
     * @type {boolean}
     * @memberof SurveyResultsApiApiV1SurveyresultsGet
     */
    readonly isExternal?: boolean

    /**
     * 
     * @type {number}
     * @memberof SurveyResultsApiApiV1SurveyresultsGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof SurveyResultsApiApiV1SurveyresultsGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof SurveyResultsApiApiV1SurveyresultsGet
     */
    readonly lastRetrieved?: Date
}

/**
 * Request parameters for apiV1SurveyresultsSendemailPost operation in SurveyResultsApi.
 * @export
 * @interface SurveyResultsApiApiV1SurveyresultsSendemailPostRequest
 */
export interface SurveyResultsApiApiV1SurveyresultsSendemailPostRequest {
    /**
     * 
     * @type {SendEmailCommand}
     * @memberof SurveyResultsApiApiV1SurveyresultsSendemailPost
     */
    readonly sendEmailCommand?: SendEmailCommand
}

/**
 * Request parameters for apiV1SurveyresultsSurveyResultIdDelete operation in SurveyResultsApi.
 * @export
 * @interface SurveyResultsApiApiV1SurveyresultsSurveyResultIdDeleteRequest
 */
export interface SurveyResultsApiApiV1SurveyresultsSurveyResultIdDeleteRequest {
    /**
     * 
     * @type {string}
     * @memberof SurveyResultsApiApiV1SurveyresultsSurveyResultIdDelete
     */
    readonly surveyResultId: string
}

/**
 * Request parameters for apiV1SurveyresultsSurveyResultIdGet operation in SurveyResultsApi.
 * @export
 * @interface SurveyResultsApiApiV1SurveyresultsSurveyResultIdGetRequest
 */
export interface SurveyResultsApiApiV1SurveyresultsSurveyResultIdGetRequest {
    /**
     * 
     * @type {string}
     * @memberof SurveyResultsApiApiV1SurveyresultsSurveyResultIdGet
     */
    readonly surveyResultId: string

    /**
     * 
     * @type {string}
     * @memberof SurveyResultsApiApiV1SurveyresultsSurveyResultIdGet
     */
    readonly languageCode?: string
}

/**
 * SurveyResultsApi - object-oriented interface
 * @export
 * @class SurveyResultsApi
 * @extends {BaseAPI}
 */
export class SurveyResultsApi extends BaseAPI {
    /**
     * 
     * @summary Get survey results
     * @param {SurveyResultsApiApiV1SurveyresultsGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SurveyResultsApi
     */
    public apiV1SurveyresultsGet(requestParameters: SurveyResultsApiApiV1SurveyresultsGetRequest = {}, options?: AxiosRequestConfig) {
        return SurveyResultsApiFp(this.configuration).apiV1SurveyresultsGet(requestParameters.id, requestParameters.hospitalId, requestParameters.surveyFormId, requestParameters.name, requestParameters.languageCode, requestParameters.periodUnit, requestParameters.startDateTime, requestParameters.endDateTime, requestParameters.isExternal, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Send manual notification of target SurveyResult
     * @param {SurveyResultsApiApiV1SurveyresultsSendemailPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SurveyResultsApi
     */
    public apiV1SurveyresultsSendemailPost(requestParameters: SurveyResultsApiApiV1SurveyresultsSendemailPostRequest = {}, options?: AxiosRequestConfig) {
        return SurveyResultsApiFp(this.configuration).apiV1SurveyresultsSendemailPost(requestParameters.sendEmailCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Delete survey result
     * @param {SurveyResultsApiApiV1SurveyresultsSurveyResultIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SurveyResultsApi
     */
    public apiV1SurveyresultsSurveyResultIdDelete(requestParameters: SurveyResultsApiApiV1SurveyresultsSurveyResultIdDeleteRequest, options?: AxiosRequestConfig) {
        return SurveyResultsApiFp(this.configuration).apiV1SurveyresultsSurveyResultIdDelete(requestParameters.surveyResultId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get survey result by Id
     * @param {SurveyResultsApiApiV1SurveyresultsSurveyResultIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SurveyResultsApi
     */
    public apiV1SurveyresultsSurveyResultIdGet(requestParameters: SurveyResultsApiApiV1SurveyresultsSurveyResultIdGetRequest, options?: AxiosRequestConfig) {
        return SurveyResultsApiFp(this.configuration).apiV1SurveyresultsSurveyResultIdGet(requestParameters.surveyResultId, requestParameters.languageCode, options).then((request) => request(this.axios, this.basePath));
    }
}
